

   MEMBER('Eventmgr.clw')                             ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EVENT004.INC'),ONCE        !Local module procedure declarations
                     END


Eventmgr_PrintVendorLabels PROCEDURE                  !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
LOC:Name             STRING(45)
LOC:CSZ              STRING(40)
LOC:Line3            STRING(40)
LOC:Line4            STRING(40)
Progress:Thermometer BYTE
Process:View         VIEW(Vendor)
                       PROJECT(VEN:Address)
                       PROJECT(VEN:Address2)
                       PROJECT(VEN:City)
                       PROJECT(VEN:CompanyName)
                       PROJECT(VEN:State)
                       PROJECT(VEN:Zip)
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

report               REPORT('Event Manager-Vendor Labels'),AT(250,500,8500,11000),PAPER(PAPER:LETTER),PRE(RPT),FONT('Arial',8,,),THOUS
detail                 DETAIL,AT(,,2750,1000),USE(?detail)
                         STRING(@S40),AT(104,156,2650,150),USE(VEN:CompanyName),LEFT
                         STRING(@S40),AT(104,344,2650,150),USE(VEN:Address),LEFT
                         STRING(@s40),AT(104,531,2650,150),USE(LOC:Line3),SKIP
                         STRING(@s40),AT(104,719,2650,150),USE(LOC:Line4)
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepStringClass                  !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_PrintVendorLabels')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:Vendor.Open
  SELF.FilesOpened = True
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Eventmgr_PrintVendorLabels',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowAlpha+ScrollSort:AllowNumeric,ScrollBy:RunTime)
  ThisReport.Init(Process:View, Relate:Vendor, ?Progress:PctText, Progress:Thermometer, ProgressMgr, VEN:Zip)
  ThisReport.CaseSensitiveValue = FALSE
  ThisReport.AddSortOrder(VEN:KeyZip)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Vendor.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Vendor.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_PrintVendorLabels',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  LOC:CSZ = CLIP(VEN:City) & ', ' & CLIP(VEN:State) & ' ' & VEN:Zip
  IF (VEN:Address2)
    LOC:Line3 = VEN:Address2
  ELSE
    LOC:Line3 = LOC:CSZ
  END
  IF (VEN:Address2)
    LOC:Line4 = LOC:CSZ
  ELSE
    LOC:Line4 = ''
  END
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

Eventmgr_PrintVendorList PROCEDURE                    !Generated from procedure template - Report

LocalRequest         LONG
FilesOpened          BYTE
Progress:Thermometer BYTE
Process:View         VIEW(Vendor)
                       PROJECT(VEN:Address)
                       PROJECT(VEN:City)
                       PROJECT(VEN:CompanyName)
                       PROJECT(VEN:State)
                       PROJECT(VEN:Zip)
                       PROJECT(VEN:VendorNumber)
                       JOIN(VPH:KeyVendorNumber,VEN:VendorNumber)
                         PROJECT(VPH:Description)
                         PROJECT(VPH:PhoneNumber)
                       END
                     END
ProgressWindow       WINDOW('Report Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

report               REPORT('Event Manager-Vendor List'),AT(1000,1719,6000,7281),PRE(RPT),FONT('Arial',10,,),THOUS
                       HEADER,AT(1000,1000,6000,677)
                         BOX,AT(10,10,5990,656),COLOR(COLOR:Black),FILL(COLOR:Silver)
                         STRING('Vendor List'),AT(10,104,5990,490),TRN,CENTER,FONT('Arial',24,,FONT:bold)
                       END
break1                 BREAK(VEN:VendorNumber)
                         HEADER,AT(0,0,6010,635)
                           BOX,AT(10,42,6000,583),USE(?Box2),COLOR(COLOR:Black)
                           LINE,AT(10,10,5990,0),USE(?Line2),COLOR(COLOR:Black),LINEWIDTH(5)
                           STRING(@S25),AT(10,63,1396,167),USE(VEN:CompanyName),TRN
                           STRING(@S25),AT(10,240,1396,167),USE(VEN:Address),TRN
                           STRING(@s2),AT(1469,427,271,167),USE(VEN:State),TRN
                           STRING(@S25),AT(21,427,1396,167),USE(VEN:City),TRN
                           STRING(@s10),AT(1688,427,969,167),USE(VEN:Zip),TRN,RIGHT(1)
                         END
detail                   DETAIL,AT(10,10,2438,271),USE(?detail)
                           STRING(@s10),AT(73,31),USE(VPH:Description)
                           STRING(@s20),AT(844,31),USE(VPH:PhoneNumber)
                         END
                       END
                       FOOTER,AT(1000,9000,6000,219)
                         STRING(@pPage <<<#p),AT(5250,31,698,135),PAGENO,USE(?PageCount),FONT('Arial',8,,FONT:regular)
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Update                 PROCEDURE(),DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepStringClass                  !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_PrintVendorList')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:Vendor.Open
  SELF.FilesOpened = True
  OPEN(ProgressWindow)
  SELF.Opened=True
  INIMgr.Fetch('Eventmgr_PrintVendorList',ProgressWindow)
  ProgressMgr.Init(ScrollSort:AllowAlpha+ScrollSort:AllowNumeric,ScrollBy:RunTime)
  ThisReport.Init(Process:View, Relate:Vendor, ?Progress:PctText, Progress:Thermometer, ProgressMgr, VEN:CompanyName)
  ThisReport.CaseSensitiveValue = FALSE
  ThisReport.AddSortOrder(VEN:KeyCompanyName)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Vendor.SetQuickScan(1,Propagate:OneMany)
  Previewer.SetINIManager(INIMgr)
  Previewer.AllowUserZoom=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Vendor.Close
  END
  IF SELF.Opened
    INIMgr.Update('Eventmgr_PrintVendorList',ProgressWindow)
  END
  ProgressMgr.Kill()
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF ProgressWindow{Prop:AcceptAll} THEN RETURN.
  VPH:VendorNumber = VEN:VendorNumber                 ! Assign linking field value
  Access:VPhones.Fetch(VPH:KeyVendorNumber)
  PARENT.Reset(Force)


ThisWindow.Update PROCEDURE

  CODE
  PARENT.Update
  VPH:VendorNumber = VEN:VendorNumber                 ! Assign linking field value
  Access:VPhones.Fetch(VPH:KeyVendorNumber)


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

Eventmgr_SplashScreen PROCEDURE                       !Generated from procedure template - Splash

LocalRequest         LONG
FilesOpened          BYTE
SoundFile            CSTRING(80)
window               WINDOW,AT(,,321,225),FONT('MS Sans Serif',8,,FONT:regular),CENTER,TIMER(10),PALETTE(256),GRAY,NOFRAME,MDI
                       PANEL,AT(0,0,321,225),BEVEL(6)
                       PANEL,AT(4,6,309,213),BEVEL(-2,1)
                       STRING('Event Manager for Windows'),AT(5,12,307,28),USE(?String2),TRN,CENTER,FONT('Comic Sans MS',24,COLOR:Fuschia,)
                       PANEL,AT(12,33,298,12),BEVEL(-1,1,09H)
                       IMAGE('SPLASH3.GIF'),AT(55,46,213,170),USE(?Image2)
                       IMAGE('CLARION.ICO'),AT(277,196,23,19),USE(?Icon2)
                       IMAGE('CLARION.ICO'),AT(22,196,23,19),USE(?Icon1)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Eventmgr_SplashScreen')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?String2
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  OPEN(window)
  SELF.Opened=True
  TARGET{Prop:Timer} = 500
  TARGET{Prop:Alrt,255} = MouseLeft
  TARGET{Prop:Alrt,254} = MouseLeft2
  TARGET{Prop:Alrt,253} = MouseRight
  Eventmgr_Preferences(TRUE)
  IF DefaultSoundEnable
    SoundFile='fanfare.wav'
    sndPlaySound(SoundFile,1)
  END
  LOOP  25 times
    TIME# = CLOCK()           !pseudo timer
    LOOP UNTIL CLOCK() > TIME# + 10
      DISPLAY
    END
    IF ?ICON1{Prop:Ypos} > 50
      ?ICON1{Prop:Ypos} = ?ICON1{Prop:Ypos} - 5
    END
    IF ?ICON2{Prop:Ypos} > 50
      ?ICON2{Prop:Ypos} = ?ICON2{Prop:Ypos} - 5
    END
  END
  
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:AlertKey
      CASE KEYCODE()
      OF MouseLeft
      OROF MouseLeft2
      OROF MouseRight
        POST(Event:CloseWindow)
      END
    OF EVENT:LoseFocus
        POST(Event:CloseWindow)
    OF EVENT:Timer
      POST(Event:CloseWindow)
    OF Event:Timer
      POST(Event:CloseWindow)
    OF Event:AlertKey
      CASE KEYCODE()
      OF MouseLeft
      OROF MouseLeft2
      OROF MouseRight
        POST(Event:CloseWindow)
      END
    ELSE
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

