

   MEMBER('Maillist.clw')                             ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABDROPS.INC'),ONCE
   INCLUDE('ABEIP.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('MAILL001.INC'),ONCE        !Local module procedure declarations
                     END


SelectPeopleForKeywords PROCEDURE                     !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
LOC:Fullname         STRING(40)
BRW1::View:Browse    VIEW(People)
                       PROJECT(PEO:IDNumber)
                       PROJECT(PEO:LastName)
                       PROJECT(PEO:FirstName)
                       PROJECT(PEO:MiddleInitial)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
LOC:Fullname           LIKE(LOC:Fullname)             !List box control field - type derived from local data
PEO:IDNumber           LIKE(PEO:IDNumber)             !Primary key field - type derived from field
PEO:LastName           LIKE(PEO:LastName)             !Browse key field - type derived from field
PEO:FirstName          LIKE(PEO:FirstName)            !Browse key field - type derived from field
PEO:MiddleInitial      LIKE(PEO:MiddleInitial)        !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a person'),AT(,,158,200),FONT('MS Sans Serif',8,,),IMM,ICON('MAIL10.ICO'),HLP('~SelectaPerson'),SYSTEM,GRAY,MDI
                       LIST,AT(8,30,141,105),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Records'),TIP('List of people'),FORMAT('160L@s40@'),FROM(Queue:Browse:1)
                       BUTTON(' {14}&Select'),AT(7,139,143,23),USE(?Select:2),RIGHT,FONT('Arial',12,,FONT:bold),MSG('Select person'),TIP('Select highlighted person'),ICON('POINT01.ICO')
                       BUTTON('Close'),AT(8,171,69,23),USE(?Close),LEFT,FONT('Arial',12,COLOR:Blue,FONT:bold),MSG('Exit window'),TIP('Exit window'),ICON('DOORWAY.ICO')
                       BUTTON('Help'),AT(81,171,69,23),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                       PANEL,AT(3,5,151,161),USE(?Panel1)
                       STRING('Type a letter to locate a person by last name'),AT(9,7),USE(?String1)
                       STRING(@s25),AT(10,17),USE(PEO:LastName)
                       PANEL,AT(3,168,152,30),USE(?Panel2)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW1::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectPeopleForKeywords')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:KeyWords.Open
  Access:PeopleKeys.UseFile
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:People,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,PEO:LastNameKey)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(,PEO:LastName,1,BRW1)
  BIND('LOC:Fullname',LOC:Fullname)
  BRW1.AddField(LOC:Fullname,BRW1.Q.LOC:Fullname)
  BRW1.AddField(PEO:IDNumber,BRW1.Q.PEO:IDNumber)
  BRW1.AddField(PEO:LastName,BRW1.Q.PEO:LastName)
  BRW1.AddField(PEO:FirstName,BRW1.Q.PEO:FirstName)
  BRW1.AddField(PEO:MiddleInitial,BRW1.Q.PEO:MiddleInitial)
  INIMgr.Fetch('SelectPeopleForKeywords',QuickWindow)
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:KeyWords.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectPeopleForKeywords',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Select:2
      !Add selected record to list
      SELF.Update  !Make sure right record in memory
      PKW:KeyWordNumber = KEY:KeyWordNumber                   !Assign field values
      PKW:KeyWordDescription = KEY:KeyWordDescription
      PKW:IDNumber = PEO:IDNumber
      IF Access:PeopleKeys.TryInsert() = Level:Notify        !Check for duplicate value
        MESSAGE(CLIP(PEO:FirstName)&' '&CLIP(PEO:LastName)&' is already a person in '&CLIP(KEY:KeyWordDescription)&' list.')
        SELECT(?Select:2)                                     !If dup, go back to select list
        CYCLE
      END
      
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1


BRW1.SetQueueRecord PROCEDURE

  CODE
  LOC:Fullname = CLIP(PEO:FirstName) & ' ' & CLIP(PEO:LastName)
  PARENT.SetQueueRecord
  SELF.Q.LOC:Fullname = LOC:Fullname                  !Assign formula result to display queue

UpdateKeyWords PROCEDURE                              !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
ActionMessage        CSTRING(40)
RecordChanged        BYTE,AUTO
LOC:Fullname         STRING(45)
BRW2::View:Browse    VIEW(PeopleKeys)
                       PROJECT(PKW:IDNumber)
                       PROJECT(PKW:KeyWordNumber)
                       JOIN(PEO:CustomerNumberKey,PKW:IDNumber)
                         PROJECT(PEO:IDNumber)
                       END
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
LOC:Fullname           LIKE(LOC:Fullname)             !List box control field - type derived from local data
PKW:IDNumber           LIKE(PKW:IDNumber)             !Primary key field - type derived from field
PKW:KeyWordNumber      LIKE(PKW:KeyWordNumber)        !Primary key field - type derived from field
PEO:IDNumber           LIKE(PEO:IDNumber)             !Related join file key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
History::KEY:Record  LIKE(KEY:RECORD),STATIC
QuickWindow          WINDOW('Update a keyword'),AT(,,235,152),FONT('MS Sans Serif',8,,),IMM,ICON('MAIL10.ICO'),HLP('~KeywordForm'),SYSTEM,GRAY,MDI
                       ENTRY(@s30),AT(51,8,168,12),USE(KEY:KeyWordDescription),LEFT,MSG('Unique Keyword'),REQ,UPR
                       LIST,AT(9,24,211,68),USE(?List),IMM,VSCROLL,MSG('Browsing Records'),FORMAT('180L~  People~@s45@'),FROM(Queue:Browse)
                       BUTTON('I'),AT(68,97,41,22),USE(?Insert:2),MSG('Add person to keyword list'),TIP('Click to add person to list'),ICON('CRDFLE12.ICO'),DEFAULT,FLAT
                       BUTTON('D'),AT(117,97,43,22),USE(?Delete:2),MSG('Delete highlighted person from list'),TIP('Click to delete highlighted person'),ICON('TRASH01.ICO'),DEFAULT,FLAT
                       BUTTON('OK'),AT(4,127,73,20),USE(?OK),LEFT,FONT('Arial',12,COLOR:Green,FONT:bold),MSG('Save and exit window'),TIP('Save & exit window'),ICON(ICON:Tick),DEFAULT
                       BUTTON('Cancel'),AT(80,127,73,20),USE(?Cancel),LEFT,FONT('Arial',12,COLOR:Red,FONT:bold),MSG('Exit without saving '),TIP('Exit without saving'),ICON(ICON:Cross)
                       BUTTON('Help'),AT(156,127,73,20),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                       PANEL,AT(3,4,225,119),USE(?Panel1)
                       PROMPT('&Description:'),AT(12,10),USE(?KEY:KeyWordDescription:Prompt)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW2                 CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW2::Sort0:Locator  StepLocatorClass                 !Default Locator
ToolbarForm          ToolbarUpdateClass               !Form Toolbar Manager
CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Keyword'
  OF ChangeRecord
    ActionMessage = 'Changing a Keyword'
  END
  QuickWindow{Prop:Text} = ActionMessage
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateKeyWords')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?KEY:KeyWordDescription
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(KEY:Record,History::KEY:Record)
  SELF.AddHistoryField(?KEY:KeyWordDescription,2)
  SELF.AddUpdateFile(Access:KeyWords)
  SELF.AddItem(?Cancel,RequestCancelled)
  Relate:KeyWords.Open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:KeyWords
  IF SELF.Request = ViewRecord
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = 0
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  BRW2.Init(?List,Queue:Browse.ViewPosition,BRW2::View:Browse,Queue:Browse,Relate:PeopleKeys,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW2.Q &= Queue:Browse
  BRW2.AddSortOrder(,PKW:KeyWordNumberKey)
  BRW2.AddRange(PKW:KeyWordNumber,Relate:PeopleKeys,Relate:KeyWords)
  BRW2.AddLocator(BRW2::Sort0:Locator)
  BRW2::Sort0:Locator.Init(,PKW:KeyWordNumber,1,BRW2)
  BIND('LOC:Fullname',LOC:Fullname)
  BRW2.AddField(LOC:Fullname,BRW2.Q.LOC:Fullname)
  BRW2.AddField(PKW:IDNumber,BRW2.Q.PKW:IDNumber)
  BRW2.AddField(PKW:KeyWordNumber,BRW2.Q.PKW:KeyWordNumber)
  BRW2.AddField(PEO:IDNumber,BRW2.Q.PEO:IDNumber)
  INIMgr.Fetch('UpdateKeyWords',QuickWindow)
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  BRW2.AddToolbarTarget(Toolbar)
  BRW2.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:KeyWords.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateKeyWords',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Insert:2
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectPeopleForKeywords
      ThisWindow.Reset
      !Display list with new added record from queue
      BRW2.ResetSort(1)
    OF ?Delete:2
      ThisWindow.Update
      !Verify deletion with user
      Relate:PeopleKeys.Delete()
      BRW2.ResetSort(1)   !Refresh list from queue
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord
        POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW2.SetQueueRecord PROCEDURE

  CODE
  LOC:Fullname = CLIP(PEO:FirstName) & ' ' & CLIP(PEO:LastName)
  PARENT.SetQueueRecord
  SELF.Q.LOC:Fullname = LOC:Fullname                  !Assign formula result to display queue

Maillist_BrowseKeyWords PROCEDURE                     !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
BRW1::View:Browse    VIEW(KeyWords)
                       PROJECT(KEY:KeyWordDescription)
                       PROJECT(KEY:KeyWordNumber)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
KEY:KeyWordDescription LIKE(KEY:KeyWordDescription)   !List box control field - type derived from field
KEY:KeyWordNumber      LIKE(KEY:KeyWordNumber)        !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Keyword Listing'),AT(,,164,200),FONT('MS Sans Serif',8,,),IMM,ICON('MAIL10.ICO'),HLP('~KeywordListing'),SYSTEM,GRAY,MDI
                       LIST,AT(11,31,140,129),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Keywords'),TIP('List of Keywords'),FORMAT('80L|M@s30@'),FROM(Queue:Browse:1)
                       BUTTON('Close'),AT(10,170,70,24),USE(?Close),LEFT,FONT('Arial',12,COLOR:Blue,FONT:bold),MSG('Exit window'),TIP('Exit window'),ICON('DOORWAY.ICO')
                       BUTTON('Help'),AT(86,170,68,24),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                       PANEL,AT(5,6,154,157),USE(?Panel1)
                       STRING('Type a letter to locate a specific keyword'),AT(13,9),USE(?String1)
                       STRING(@s30),AT(13,20),USE(KEY:KeyWordDescription)
                       BUTTON('&Insert'),AT(19,74,55,20),USE(?Insert:2),HIDE,LEFT,MSG('Add a keyword'),TIP('Click to add a keyword')
                       BUTTON('&Change'),AT(19,99,55,20),USE(?Change:2),HIDE,LEFT,MSG('Change highlighted keyword'),TIP('Click to change highlighted keyword'),DEFAULT
                       BUTTON('&Delete'),AT(21,126,55,20),USE(?Delete:2),HIDE,LEFT,MSG('Delete highlighted keyword'),TIP('Click to delete highlighted keyword')
                       PANEL,AT(5,166,154,32),USE(?Panel2)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
                     END

BRW1::Sort0:Locator  IncrementalLocatorClass          !Default Locator
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END


  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Maillist_BrowseKeyWords')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:KeyWords.Open
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:KeyWords,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,KEY:KeyWordDescriptionKey)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(?KEY:KeyWordDescription,KEY:KeyWordDescription,1,BRW1)
  BRW1.AddField(KEY:KeyWordDescription,BRW1.Q.KEY:KeyWordDescription)
  BRW1.AddField(KEY:KeyWordNumber,BRW1.Q.KEY:KeyWordNumber)
  Resizer.Init(AppStrategy:Spread)
  SELF.AddItem(Resizer)
  INIMgr.Fetch('Maillist_BrowseKeyWords',QuickWindow)
  Resizer.Resize                                      !Resize/Reset required after window size altered by INI manager
  Resizer.Reset
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:KeyWords.Close
  END
  IF SELF.Opened
    INIMgr.Update('Maillist_BrowseKeyWords',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    UpdateKeyWords
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert:2
    SELF.ChangeControl=?Change:2
    SELF.DeleteControl=?Delete:2
  END


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.DeferMoves=False
  SELF.SetParentDefaults

Maillist_Main PROCEDURE                               !Generated from procedure template - Frame

LocalRequest         LONG
FilesOpened          BYTE
CurrentTab           STRING(80)
SplashProcedureThread LONG
DisplayDayString STRING('Sunday   Monday   Tuesday  WednesdayThursday Friday   Saturday ')
DisplayDayText   STRING(9),DIM(7),OVER(DisplayDayString)
AppFrame             APPLICATION('Mailing List Manager'),AT(,,400,261),FONT('MS Sans Serif',8,,),ICON('MAIL10.ICO'),HLP('~MailingListManager'),STATUS(-1,80,120,45),WALLPAPER('Sky1.bmp'),SYSTEM,MAX,MAXIMIZE,RESIZE,IMM
                       MENUBAR
                         MENU('&File')
                           ITEM('&Export People File'),USE(?FileExportPeopleFile)
                           ITEM('&Print Setup ...'),USE(?PrintSetup),MSG('Setup printer'),STD(STD:PrintSetup)
                           ITEM,SEPARATOR
                           ITEM('E&xit'),USE(?Exit),MSG('Exit this application'),STD(STD:Close)
                         END
                         MENU('&Edit')
                           ITEM('Cu&t'),USE(?Cut),MSG('Remove item to Windows Clipboard'),STD(STD:Cut)
                           ITEM('&Copy'),USE(?Copy),MSG('Copy item to Windows Clipboard'),STD(STD:Copy)
                           ITEM('&Paste'),USE(?Paste),MSG('Paste contents of Windows Clipboard'),STD(STD:Paste)
                         END
                         MENU('&Browse')
                           ITEM('&People to send mailings'),USE(?BrowsePeople),MSG('Browse People to send mailings')
                           ITEM('List of &Mailing options'),USE(?BrowseMailers),MSG('Browse List of Mailing options')
                           ITEM('List of &Keywords'),USE(?BrowseKeyWords),MSG('Listing of valid Keywords')
                           ITEM('List of &States'),USE(?BrowseStateListing)
                         END
                         MENU('&Reports'),USE(?ReportMenu),MSG('Report data')
                           MENU('&Summary Reports'),USE(?ReportsSummaryReports)
                             ITEM('People by &State/City'),USE(?PeoplebyStateCity)
                             ITEM('People by Alphabetical Order'),USE(?PeoplebyAlphabeticalOrder)
                             ITEM('People by &Keyword'),USE(?ReportsSummaryPeopleKeyword)
                             ITEM('Mailing List Summary '),USE(?MailingListSummary)
                           END
                           ITEM('&Labels'),USE(?ReportsLabels)
                         END
                         MENU('&Window'),MSG('Create and Arrange windows'),STD(STD:WindowList)
                           ITEM('T&ile'),USE(?Tile),MSG('Make all open windows visible'),STD(STD:TileWindow)
                           ITEM('&Cascade'),USE(?Cascade),MSG('Stack all open windows'),STD(STD:CascadeWindow)
                           ITEM('&Arrange Icons'),USE(?Arrange),MSG('Align all window icons'),STD(STD:ArrangeIcons)
                         END
                         MENU('&Help'),MSG('Windows Help')
                           ITEM('&Contents'),USE(?Helpindex),HLP('~TheMailingListManagerProgram'),MSG('View the contents of the help file'),STD(STD:HelpIndex)
                           ITEM('&Search for Help On...'),USE(?HelpSearch),MSG('Search for help on a subject'),STD(STD:HelpSearch)
                           ITEM('&How to Use Help'),USE(?HelpOnHelp),MSG('How to use Windows Help'),STD(STD:HelpOnHelp)
                           ITEM('&About Mail List'),USE(?HelpAbout)
                         END
                       END
                       TOOLBAR,AT(0,0,399,25)
                         BUTTON,AT(82,2,25,20),USE(?StateList),MSG('Browse the State List'),TIP('Click to Browse the State List'),ICON('CTRUSA.ICO'),FLAT
                         BUTTON,AT(119,2,16,20),USE(?Toolbar:Top,Toolbar:Top),DISABLE,TIP('Go to the First Page'),ICON('VCRFIRST.ICO'),FLAT
                         BUTTON,AT(135,2,16,20),USE(?Toolbar:PageUp,Toolbar:PageUp),DISABLE,TIP('Go to the Prior Page'),ICON('VCRPRIOR.ICO'),FLAT
                         BUTTON,AT(151,2,16,20),USE(?Toolbar:Up,Toolbar:Up),DISABLE,TIP('Go to the Prior Record'),ICON('VCRUP.ICO'),FLAT
                         BUTTON,AT(167,2,16,20),USE(?Toolbar:Locate,Toolbar:Locate),DISABLE,TIP('Locate record'),ICON('FIND.ICO'),FLAT
                         BUTTON,AT(183,2,16,20),USE(?Toolbar:Down,Toolbar:Down),DISABLE,TIP('Go to the Next Record'),ICON('VCRDOWN.ICO'),FLAT
                         BUTTON,AT(199,2,16,20),USE(?Toolbar:PageDown,Toolbar:PageDown),DISABLE,TIP('Go to the Next Page'),ICON('VCRNEXT.ICO'),FLAT
                         BUTTON,AT(215,2,16,20),USE(?Toolbar:Bottom,Toolbar:Bottom),DISABLE,TIP('Go to the Last Page'),ICON('VCRLAST.ICO'),FLAT
                         BUTTON,AT(235,2,16,20),USE(?Toolbar:Select,Toolbar:Select),DISABLE,TIP('Select This Record'),ICON('MARK.ICO'),FLAT
                         BUTTON,AT(251,2,16,20),USE(?Toolbar:Insert,Toolbar:Insert),DISABLE,TIP('Insert a New Record'),ICON('INSERT.ICO'),FLAT
                         BUTTON,AT(267,2,16,20),USE(?Toolbar:Change,Toolbar:Change),DISABLE,TIP('Edit This Record'),ICON('EDIT.ICO'),FLAT
                         BUTTON,AT(283,2,16,20),USE(?Toolbar:Delete,Toolbar:Delete),DISABLE,TIP('Delete This Record'),ICON('DELETE.ICO'),FLAT
                         BUTTON,AT(303,2,16,20),USE(?Toolbar:History,Toolbar:History),DISABLE,TIP('Previous value'),ICON('DITTO.ICO'),FLAT
                         BUTTON,AT(319,2,16,20),USE(?Toolbar:Help,Toolbar:Help),DISABLE,TIP('Get Help'),ICON('HELP.ICO'),FLAT
                         BUTTON,AT(56,2,25,20),USE(?KeyWordList),MSG('Brows the Keyword List'),TIP('Click to Browse the Keyword List'),ICON('WRITI003.ICO'),FLAT
                         BUTTON,AT(4,2,25,20),USE(?MailList),MSG('Browse Mail Lists'),TIP('Click to Browse the Mail Lists'),ICON('MAIL10.ICO'),FLAT
                         BUTTON,AT(30,2,25,20),USE(?PeopleList),MSG('Brows the People List'),TIP('Click to Browse the People List'),ICON('MISC28.ICO'),FLAT
                       END
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass

  CODE
  GlobalResponse = ThisWindow.Run()

Menu::ReportMenu ROUTINE                              !Code for menu items on ?ReportMenu
  CASE ACCEPTED()
  OF ?ReportsLabels
    START(Maillist_WindowPickReport, 25000)
  END
Menu::ReportsSummaryReports ROUTINE                   !Code for menu items on ?ReportsSummaryReports
  CASE ACCEPTED()
  OF ?PeoplebyStateCity
    START(Maillist_ReportStateCity, 25000)
  OF ?PeoplebyAlphabeticalOrder
    START(Maillist_ReportPeopleAlpha, 25000)
  OF ?ReportsSummaryPeopleKeyword
    START(Maillist_ReportPeopleKeys, 25000)
  OF ?MailingListSummary
    START(Maillist_ReportMailingList, 25000)
  END

ThisWindow.Ask PROCEDURE

  CODE
  IF NOT INRANGE(AppFrame{Prop:Timer},1,100)
    AppFrame{Prop:Timer} = 100
  END
    AppFrame{Prop:StatusText,3} = CLIP(DisplayDayText[(TODAY()%7)+1]) & ', ' & FORMAT(TODAY(),@D4)
    AppFrame{Prop:StatusText,2} = FORMAT(CLOCK(),@T3)
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('Maillist_Main')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = 1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  OPEN(AppFrame)
  SELF.Opened=True
  INIMgr.Fetch('Maillist_Main',AppFrame)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.Opened
    INIMgr.Update('Maillist_Main',AppFrame)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Toolbar:Top
    OROF ?Toolbar:PageUp
    OROF ?Toolbar:Up
    OROF ?Toolbar:Locate
    OROF ?Toolbar:Down
    OROF ?Toolbar:PageDown
    OROF ?Toolbar:Bottom
    OROF ?Toolbar:Select
    OROF ?Toolbar:Insert
    OROF ?Toolbar:Change
    OROF ?Toolbar:Delete
    OROF ?Toolbar:History
    OROF ?Toolbar:Help
      IF SYSTEM{PROP:Active} <> THREAD()
        POST(EVENT:Accepted,ACCEPTED(),SYSTEM{Prop:Active} )
        CYCLE
      END
    ELSE
      DO Menu::ReportMenu                             !Process menu items on ?ReportMenu menu
      DO Menu::ReportsSummaryReports                  !Process menu items on ?ReportsSummaryReports menu
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?FileExportPeopleFile
      START(Maillist_WindowExportFile, 25000)
    OF ?BrowsePeople
      START(Maillist_BrowsePeople, 050000)
    OF ?BrowseMailers
      START(Maillist_BrowseMailers, 050000)
    OF ?BrowseKeyWords
      START(Maillist_BrowseKeyWords, 050000)
    OF ?BrowseStateListing
      START(Maillist_BrowseStateFile, 25000)
    OF ?HelpAbout
      START(Maillist_WindowAbout, 25000)
    OF ?StateList
      START(Maillist_BrowseStateFile, 25000)
    OF ?KeyWordList
      START(Maillist_BrowseKeyWords, 25000)
    OF ?MailList
      START(Maillist_BrowseMailers, 25000)
    OF ?PeopleList
      START(Maillist_BrowsePeople, 25000)
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:OpenWindow
      SplashProcedureThread = START(Maillist_SplashScreen)
    OF Event:Timer
      AppFrame{Prop:StatusText,3} = CLIP(DisplayDayText[(TODAY()%7)+1]) & ', ' & FORMAT(TODAY(),@D4)
      AppFrame{Prop:StatusText,2} = FORMAT(CLOCK(),@T3)
    ELSE
      IF SplashProcedureThread
        IF EVENT() = Event:Accepted
          POST(Event:CloseWindow,,SplashProcedureThread)
          SplashPRocedureThread = 0
        END
     END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

WindowResultNoKeyword PROCEDURE                       !Generated from procedure template - Window

LocalRequest         LONG
FilesOpened          BYTE
LOC:FullName         STRING(45)
LOC:StateZip         STRING(15)
LOC:FullSex          STRING(10)
BRW2::View:Browse    VIEW(People)
                       PROJECT(PEO:City)
                       PROJECT(PEO:Birthdate)
                       PROJECT(PEO:Sex)
                       PROJECT(PEO:State)
                       PROJECT(PEO:ZipCode)
                       PROJECT(PEO:IDNumber)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
LOC:FullName           LIKE(LOC:FullName)             !List box control field - type derived from local data
GLO:FilterString       LIKE(GLO:FilterString)         !Browse hot field - type derived from global data
PKW:KeyWordDescription LIKE(PKW:KeyWordDescription)   !Browse hot field - type derived from field
LOC:StateZip           LIKE(LOC:StateZip)             !Browse hot field - type derived from local data
LOC:FullSex            LIKE(LOC:FullSex)              !Browse hot field - type derived from local data
PEO:City               LIKE(PEO:City)                 !Browse hot field - type derived from field
PEO:Birthdate          LIKE(PEO:Birthdate)            !Browse hot field - type derived from field
PEO:Sex                LIKE(PEO:Sex)                  !Browse hot field - type derived from field
PEO:State              LIKE(PEO:State)                !Browse hot field - type derived from field
PEO:ZipCode            LIKE(PEO:ZipCode)              !Browse hot field - type derived from field
PEO:IDNumber           LIKE(PEO:IDNumber)             !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BRW3::View:Browse    VIEW(PeopleKeys)
                       PROJECT(PKW:KeyWordDescription)
                       PROJECT(PKW:IDNumber)
                       PROJECT(PKW:KeyWordNumber)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?List:2
PKW:KeyWordDescription LIKE(PKW:KeyWordDescription)   !List box control field - type derived from field
PKW:IDNumber           LIKE(PKW:IDNumber)             !Primary key field - type derived from field
PKW:KeyWordNumber      LIKE(PKW:KeyWordNumber)        !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
window               WINDOW('Selection Results'),AT(,,259,146),ICON('MAIL10.ICO'),HLP('~ResultWindow'),SYSTEM,GRAY,RESIZE,MDI,IMM
                       LIST,AT(5,4,113,115),USE(?List),IMM,VSCROLL,MSG('Browsing Selection Records'),TIP('Selected people'),FORMAT('180L~  Name~@s45@'),FROM(Queue:Browse)
                       BUTTON('Add to List'),AT(9,124,74,18),USE(?Add),LEFT,FONT('Arial',12,,FONT:bold),MSG('Add peole to mailing list'),TIP('Add people to mailing list'),ICON('CRDFLE12.ICO')
                       BUTTON('Return '),AT(99,124,72,18),USE(?Close),LEFT,FONT('Arial',12,COLOR:Blue,FONT:bold),MSG('Return to selection window without saving'),TIP('Return to selection window without saving'),ICON('RETURN.ICO')
                       BUTTON('Help'),AT(186,124,66,18),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                       PANEL,AT(126,6,130,114),USE(?Panel1)
                       STRING(''),AT(132,8),USE(?String5)
                       PANEL,AT(130,10,121,58),USE(?Panel2)
                       STRING(@s25),AT(147,17),USE(PEO:City),TRN,FONT('System',10,COLOR:Maroon,FONT:bold)
                       STRING(@s15),AT(147,28),USE(LOC:StateZip),FONT('System',10,COLOR:Maroon,FONT:bold)
                       STRING('Profile Info'),AT(132,11,21,55),USE(?String8),TRN,FONT('Arial',12,COLOR:Maroon,FONT:bold),ANGLE(2700)
                       BOX,AT(132,12,117,54),USE(?Box1),COLOR(COLOR:Maroon),FILL(COLOR:Silver)
                       LINE,AT(144,12,0,53),USE(?Line1),COLOR(COLOR:Maroon),LINEWIDTH(1)
                       STRING(@d2),AT(180,40),USE(PEO:Birthdate),FONT('System',10,COLOR:Maroon,FONT:bold)
                       STRING('Birthdate:'),AT(147,40),USE(?String6),FONT('System',10,COLOR:Maroon,FONT:bold)
                       STRING(@s10),AT(163,52),USE(LOC:FullSex),FONT(,,COLOR:Maroon,)
                       STRING('Sex:'),AT(147,52),USE(?String7),FONT(,,COLOR:Maroon,)
                       LIST,AT(131,73,120,42),USE(?List:2),IMM,VSCROLL,MSG('Browsing Keyword Records'),TIP('Keywords of selected person'),FORMAT('120L~ Keywords~C@s30@'),FROM(Queue:Browse:1)
                       PANEL,AT(4,122,253,23),USE(?Panel3)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW2                 CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
ResetQueue             PROCEDURE(BYTE ResetMode),DERIVED
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW2::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW3                 CLASS(BrowseClass)               !Browse using ?List:2
Q                      &Queue:Browse:1                !Reference to browse queue
                     END

BRW3::Sort0:Locator  StepLocatorClass                 !Default Locator

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('WindowResultNoKeyword')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?List
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:MailPeople.Open
  Access:Mailers.UseFile
  SELF.FilesOpened = True
  BRW2.Init(?List,Queue:Browse.ViewPosition,BRW2::View:Browse,Queue:Browse,Relate:People,SELF)
  BRW3.Init(?List:2,Queue:Browse:1.ViewPosition,BRW3::View:Browse,Queue:Browse:1,Relate:PeopleKeys,SELF)
  OPEN(window)
  SELF.Opened=True
  BRW2.Q &= Queue:Browse
  BRW2.AddSortOrder(,PEO:CustomerNumberKey)
  BRW2.AddLocator(BRW2::Sort0:Locator)
  BRW2::Sort0:Locator.Init(,PEO:IDNumber,1,BRW2)
  BIND('LOC:FullName',LOC:FullName)
  BIND('GLO:FilterString',GLO:FilterString)
  BIND('LOC:StateZip',LOC:StateZip)
  BIND('LOC:FullSex',LOC:FullSex)
  BRW2.AddField(LOC:FullName,BRW2.Q.LOC:FullName)
  BRW2.AddField(GLO:FilterString,BRW2.Q.GLO:FilterString)
  BRW2.AddField(PKW:KeyWordDescription,BRW2.Q.PKW:KeyWordDescription)
  BRW2.AddField(LOC:StateZip,BRW2.Q.LOC:StateZip)
  BRW2.AddField(LOC:FullSex,BRW2.Q.LOC:FullSex)
  BRW2.AddField(PEO:City,BRW2.Q.PEO:City)
  BRW2.AddField(PEO:Birthdate,BRW2.Q.PEO:Birthdate)
  BRW2.AddField(PEO:Sex,BRW2.Q.PEO:Sex)
  BRW2.AddField(PEO:State,BRW2.Q.PEO:State)
  BRW2.AddField(PEO:ZipCode,BRW2.Q.PEO:ZipCode)
  BRW2.AddField(PEO:IDNumber,BRW2.Q.PEO:IDNumber)
  BRW3.Q &= Queue:Browse:1
  BRW3.AddSortOrder(,PKW:IDKeyWordKey)
  BRW3.AddRange(PKW:IDNumber,Relate:PeopleKeys,Relate:People)
  BRW3.AddLocator(BRW3::Sort0:Locator)
  BRW3::Sort0:Locator.Init(,PKW:KeyWordNumber,1,BRW3)
  BRW3.AddField(PKW:KeyWordDescription,BRW3.Q.PKW:KeyWordDescription)
  BRW3.AddField(PKW:IDNumber,BRW3.Q.PKW:IDNumber)
  BRW3.AddField(PKW:KeyWordNumber,BRW3.Q.PKW:KeyWordNumber)
  !Set variable filter for browse
  BRW2.SetFilter(GLO:FilterString)
  INIMgr.Fetch('WindowResultNoKeyword',window)
  BRW2.AddToolbarTarget(Toolbar)
  BRW2.ToolbarItem.HelpButton = ?Help
  BRW3.AddToolbarTarget(Toolbar)
  BRW3.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:MailPeople.Close
  END
  IF SELF.Opened
    INIMgr.Update('WindowResultNoKeyword',window)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Add
       POST(Event:CloseWindow)
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Add
      ThisWindow.Update
      !Adding the displayed people to the mailing list
      SET(BRW2::View:Browse)                     !Set to top of the view
      LOOP UNTIL BRW2.Next()                   !Get a record
         CLEAR(MAP:Record)                       !Clear out garbage
         MAP:IDNumber = PEO:IDNumber             !Assign view values
         MAP:MailerNumber = MAI:MailerNumber     !  to values in file
         MAP:Status = 'Active'
         IF Access:MailPeople.TryInsert() THEN CYCLE.    !If a duplicate entry, go to next record
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW2.ResetQueue PROCEDURE(BYTE ResetMode)

  CODE
  PARENT.ResetQueue(ResetMode)
  !If no matching records, give message
  IF ~RECORDS(SELF.ListQueue)
    MESSAGE('NO MATCHING RECORDS FOUND','Selection Criteria',ICON:Exclamation)
    POST(EVENT:CloseWindow)
  END


BRW2.SetQueueRecord PROCEDURE

  CODE
  ! Make screen values look better
  LOC:FullSex = CHOOSE(PEO:Sex = 'M','Male','Female')
  LOC:FullName = CLIP(PEO:FirstName) & ' ' & CLIP(PEO:LastName)
  LOC:StateZip = CLIP(PEO:State) & ' ' & PEO:ZipCode
  PARENT.SetQueueRecord
  SELF.Q.LOC:FullName = LOC:FullName                  !Assign formula result to display queue
  SELF.Q.LOC:StateZip = LOC:StateZip                  !Assign formula result to display queue

WindowSelectQuery PROCEDURE                           !Generated from procedure template - Window

LocalRequest         LONG
LOC:Input            STRING(20)
LOC:Dimension        BYTE
LOC:EquateNumber     SHORT
LOC:YPosition        SHORT
LOC:XPosition        SHORT
FilesOpened          BYTE
LOC:Fields           STRING(20),DIM(4)
LOC:Operator         STRING(2),DIM(4)
LOC:Value            STRING(30),DIM(4)
LOC:FilterExpression STRING(255)
LOC:JoinValue        STRING(3),DIM(3)
LOC:State            STRING(2)
LOC:Sex              STRING(8)
LOC:Keyword          STRING(20)
LOC:Date             LONG
FDB2::View:FileDrop  VIEW(STATES)
                       PROJECT(STA:CODE)
                     END
Queue:FileDrop       QUEUE                            !Queue declaration for browse/combo box using ?STA:CODE
STA:CODE               LIKE(STA:CODE)                 !List box control field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
FDB3::View:FileDrop  VIEW(KeyWords)
                       PROJECT(KEY:KeyWordDescription)
                       PROJECT(KEY:KeyWordNumber)
                     END
Queue:FileDrop:1     QUEUE                            !Queue declaration for browse/combo box using ?KEY:KeyWordDescription
KEY:KeyWordDescription LIKE(KEY:KeyWordDescription)   !List box control field - type derived from field
KEY:KeyWordNumber      LIKE(KEY:KeyWordNumber)        !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
window               WINDOW('Build Selection Criteria'),AT(,,283,134),ICON('MAIL10.ICO'),HLP('~SelectionCriteriaWindow'),SYSTEM,GRAY,MDI,IMM
                       PANEL,AT(5,2,276,98),USE(?Panel1)
                       STRING('Select criteria for limiting people in a mailing list:  (Maximum four criteria)'),AT(24,5),USE(?String1)
                       STRING('Field Name'),AT(55,14),USE(?String6),TRN
                       STRING('Operator'),AT(112,14),USE(?String7),TRN
                       STRING('Value'),AT(164,14),USE(?String8),TRN
                       STRING('Criteria One'),AT(14,22),USE(?String2)
                       STRING('Criteria Two'),AT(14,43),USE(?String3)
                       STRING('Criteria Three'),AT(9,65),USE(?String4)
                       STRING('Criteria Four'),AT(13,86),USE(?String5)
                       COMBO(@s18),AT(55,22,53,10),USE(LOC:Fields[1]),VSCROLL,MSG('Field names for selection'),READONLY,DROP(5),FROM('First Name|Last Name|City|State|ZipCode|Birthdate|Sex|Keyword')
                       COMBO(@s5),AT(114,22,25,10),USE(LOC:Operator[1]),MSG('Logical operator selections'),READONLY,DROP(6),FROM('=|<<>|<<|>|>=|<<=')
                       ENTRY(@s30),AT(145,22,128,10),USE(LOC:Value[1]),MSG('Enter a value for field name')
                       OPTION('Join'),AT(55,30,163,13),USE(LOC:JoinValue[1]),TRN,MSG('Local Storage of Join of Criteria')
                         RADIO('NONE'),AT(78,33),USE(?LOC:JoinValue:Radio1),MSG('Join operator: None')
                         RADIO('AND'),AT(125,33),USE(?LOC:JoinValue:Radio2),MSG('Join criteria: AND')
                         RADIO('OR'),AT(166,33),USE(?LOC:JoinValue:Radio3),MSG('Join criteria: OR')
                       END
                       COMBO(@s15),AT(55,43,53,10),USE(LOC:Fields[2]),DISABLE,VSCROLL,MSG('Field names for selection'),READONLY,DROP(5),FROM('First Name|Last Name|City|State|ZipCode|Birthdate|Sex|Keyword')
                       COMBO(@s2),AT(114,43,25,10),USE(LOC:Operator[2]),DISABLE,MSG('Logical operators for selection'),READONLY,DROP(6),FROM('=|<<>|<<|>|>=|<<=')
                       ENTRY(@s30),AT(145,43,128,10),USE(LOC:Value[2]),DISABLE,MSG('Enter value for field name')
                       OPTION('Join'),AT(55,51,165,14),USE(LOC:JoinValue[2]),DISABLE,TRN,MSG('Local Storage of Join of Criteria')
                         RADIO('NONE'),AT(79,54),USE(?LOC:JoinValue:Radio1:2),MSG('Join criteria: NONE')
                         RADIO('AND'),AT(126,54),USE(?LOC:JoinValue:Radio2:2),MSG('Join criteria: AND')
                         RADIO('OR'),AT(167,54),USE(?LOC:JoinValue:Radio3:2),MSG('Join criteria: OR')
                       END
                       COMBO(@s15),AT(55,65,53,10),USE(LOC:Fields[3]),DISABLE,VSCROLL,MSG('Field names for selection'),READONLY,DROP(5),FROM('First Name|Last Name|City|State|ZipCode|Birthdate|Sex|Keyword')
                       COMBO(@s2),AT(114,65,25,10),USE(LOC:Operator[3]),DISABLE,MSG('Logical operators for selection'),READONLY,DROP(6),FROM('=|<<>|<<|>|>=|<<=')
                       ENTRY(@s30),AT(145,65,128,10),USE(LOC:Value[3]),DISABLE,MSG('Enter value for field name')
                       OPTION('Join'),AT(55,73,166,13),USE(LOC:JoinValue[3]),DISABLE,TRN,MSG('Local Storage of Join of Criteria')
                         RADIO('NONE'),AT(79,76),USE(?LOC:JoinValue:Radio1:3),MSG('Join criteria: NONE')
                         RADIO('AND'),AT(126,76),USE(?LOC:JoinValue:Radio2:3),MSG('Join criteria: AND')
                         RADIO('OR'),AT(167,76),USE(?LOC:JoinValue:Radio3:3),MSG('Join criteria: OR')
                       END
                       COMBO(@s15),AT(55,86,53,10),USE(LOC:Fields[4]),DISABLE,VSCROLL,MSG('Field names for selection'),READONLY,DROP(5),FROM('First Name|Last Name|City|State|ZipCode|Birthdate|Sex|Keyword')
                       COMBO(@s2),AT(114,86,25,10),USE(LOC:Operator[4]),DISABLE,MSG('Logical operators for selection'),READONLY,DROP(6),FROM('=|<<>|<<|>|>=|<<=')
                       ENTRY(@s30),AT(145,86,128,10),USE(LOC:Value[4]),DISABLE,MSG('Enter value for field name')
                       PANEL,AT(5,102,276,28),USE(?Panel2)
                       BUTTON('Build List'),AT(10,106,65,19),USE(?Display),LEFT,FONT('Arial',12,COLOR:Maroon,FONT:bold),MSG('Show people matching criteria'),TIP('Show people matching criteria'),ICON('BUILD.ICO')
                       BUTTON('Close'),AT(83,106,59,19),USE(?Close),LEFT,FONT('Arial',12,COLOR:Blue,FONT:bold),MSG('Exit Window'),TIP('Exit window'),ICON('DOORWAY.ICO')
                       BUTTON('Clear '),AT(150,106,59,19),USE(?Clear),LEFT,FONT('Arial',12,COLOR:Navy,FONT:bold),MSG('Clear Screen for new selection criteria'),TIP('Clear screen and enter new criteria'),ICON('CLEAR.ICO')
                       BUTTON('Help'),AT(217,106,59,19),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                       COMBO(@s2),AT(11,94,128,10),USE(LOC:Input,,?STA:CODE),HIDE,VSCROLL,MSG('Pick a state'),READONLY,FORMAT('8L@s2@'),DROP(5),FROM(Queue:FileDrop)
                       ENTRY(@D2),AT(145,99,128,10),USE(LOC:Date),HIDE,MSG('Enter a date (mm/dd/yyyy format)')
                       COMBO(@s6),AT(11,101,128,10),USE(LOC:Input,,?LOC:Sex),HIDE,VSCROLL,MSG('Pick male or female'),READONLY,DROP(5),FROM('Male|Female')
                       COMBO(@s25),AT(145,94,128,10),USE(LOC:Input,,?KEY:KeyWordDescription),HIDE,VSCROLL,MSG('Pick a keyword'),READONLY,FORMAT('120L@s30@'),DROP(5),FROM(Queue:FileDrop:1)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeSelected           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
FDB2                 CLASS(FileDropClass)             !File drop manager
Q                      &Queue:FileDrop                !Reference to display queue
                     END

FDB3                 CLASS(FileDropClass)             !File drop manager
Q                      &Queue:FileDrop:1              !Reference to display queue
                     END


  CODE
  GlobalResponse = ThisWindow.Run()

ValueFieldLookup    ROUTINE
!This routine moves the correct combo or entry field over the proper value field.  The value field
!is a dimensioned field and the combo or entry field that can be moved is dependant on the field
!that the user selected in the first combo field (marked LOC:Fields)
  LOC:EquateNumber{PROP:Hide} = TRUE           !Hide the current criteria value field
  ?STA:Code{PROP:Hide} = TRUE                  !Hide the state combo box
  ?LOC:Sex{PROP:Hide} = TRUE                   !Hide the sex combo box
  ?KEY:KeyWordDescription{PROP:Hide} = TRUE    !Hide the keyword combo box
  ?LOC:Date{PROP:Hide} = TRUE                  !Hide the date entry field
  CASE LOC:Fields[LOC:Dimension]               !Look at the fields value for the current criteria
  OF 'State'                                   !If it is State
    ?STA:Code{PROP:XPos} = LOC:XPosition         !Get the criteria value field location (horizontal)
    ?STA:Code{PROP:YPos} = LOC:YPosition         !Get the criteria value field location (vertical)
    ?STA:Code{PROP:Hide} = FALSE                 !Show the state combo in the correct position
  OF 'Birthdate'                               !If it is Birthdate
    ?LOC:Date{PROP:XPos} = LOC:XPosition         !Get the criteria value field location (horizontal)
    ?LOC:Date{PROP:YPos} = LOC:YPosition         !Get the criteria value field location (vertical)
    ?LOC:Date{PROP:Hide} = FALSE                 !Show the date entry field in the correct position
  OF 'Sex'                                     !If it is Sex
    ?LOC:Sex{PROP:XPos} = LOC:XPosition          !Get the criteria value field location (horizontal)
    ?LOC:Sex{PROP:YPos} = LOC:YPosition          !Get the criteria value field location (vertical)
    ?LOC:Sex{PROP:Hide} = FALSE                  !Show the sex combo in the correct position
  OF 'Keyword'                                        !If it is Keyword
    ?KEY:KeyWordDescription{PROP:XPos} = LOC:XPosition  !Get the criteria value field location (horizontal)
    ?KEY:KeyWordDescription{PROP:YPos} = LOC:YPosition  !Get the criteria value field location (vertical)
    ?KEY:KeyWordDescription{PROP:Hide} = FALSE          !Show the keyword combo in the correct position
  ELSE                                         !If it is anything else
    LOC:EquateNumber{PROP:Hide} = FALSE          !Show the current criteria value field
  END
SelectWhat     ROUTINE
!This routine forces the selection of a control out to tab order.  This is needed when one of
!the "hidden" combo/entry fields is displayed in place of the selection criteria value field.
!The selected control depends of the value choosen in the criteria field value.
  CASE LOC:Fields[LOC:Dimension]           !Check the value of current field value
  OF 'State'                               !If state,
    SELECT(?STA:Code)                      !  select state combo
  OF 'Birthdate'                           !If birthdate,
    SELECT(?LOC:Date)                      !  select date entry field
  OF 'Sex'                                 !If sex,
    SELECT(?LOC:Sex)                       !  select sex combo
  OF 'Keyword'                             !If keyword,
    SELECT(?KEY:KeyWordDescription)        !  select keyword combo
  ELSE                                     !If anything else,
    SELECT(LOC:EquateNumber)               !  select current value field
  END
List2EntryField  ROUTINE
!This routine displays the currently hidden criteria value with the newly entered data from the
!floating field.  It requires the current criteria number.
  CASE LOC:Dimension                        !Which criteria
  OF 1
    ?LOC:Value_1{PROP:Hide} = FALSE       !Show first criteria value
  OF 2
    ?LOC:Value_2{PROP:Hide} = FALSE       !Show second criteria value
  OF 3
    ?LOC:Value_3{PROP:Hide} = FALSE       !Show third criteria value
  OF 4
    ?LOC:Value_4{PROP:Hide} = FALSE       !Show forth criteria value
  END
!This code helps to handle users using the keyboard to go through the fields.  Because the
!floating fields are not in correct tab order with the other fields, the program needs to be told
!what field to go to next after leaving a floating control.
  IF KEYCODE() = ShiftTab               !if the user is tabbing backwards
    SELECT(LOC:EquateNumber - 1)        !select the control right before the criteria value field
  ELSE                                  !if the user is tabbing forwards (or whatever)
    SELECT(LOC:EquateNumber + 1)        !select the control right after the criteria value field
  END
  DISPLAY
ClearValues     ROUTINE
!This routine is used to clear the values from the next selecting criteria if the NONE join
!criteria is selected
  CLEAR(LOC:Fields[LOC:Dimension])         !Clear the field value
  CLEAR(LOC:Operator[LOC:Dimension])       ! operator
  CLEAR(LOC:Value[LOC:Dimension])          ! value
  IF LOC:Dimension <> 4                    ! and the next join criteria if not
    CLEAR(LOC:JoinValue[LOC:Dimension])    !   on the last criteria
  END
  DISPLAY

ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('WindowSelectQuery')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Panel1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  !Initialize operator values and first radio button set
  LOOP X# = 1 TO 4           !Set the default operator to =
    LOC:Operator[X#] = '='
  END
  LOC:JoinValue[1] = 'NONE'  !Set the first join to None
  SELF.AddItem(?Close,RequestCancelled)
  Relate:KeyWords.Open
  Access:People.UseFile
  Access:PeopleKeys.UseFile
  SELF.FilesOpened = True
  OPEN(window)
  SELF.Opened=True
  INIMgr.Fetch('WindowSelectQuery',window)
  FDB2.Init(?STA:CODE,Queue:FileDrop.ViewPosition,FDB2::View:FileDrop,Queue:FileDrop,Relate:STATES,ThisWindow)
  FDB2.Q &= Queue:FileDrop
  FDB2.AddSortOrder()
  FDB2.AddField(STA:CODE,FDB2.Q.STA:CODE)
  FDB2.AddUpdateField(STA:CODE,LOC:Input)
  ThisWindow.AddItem(FDB2.WindowComponent)
  FDB2.DefaultFill = 0
  FDB3.Init(?KEY:KeyWordDescription,Queue:FileDrop:1.ViewPosition,FDB3::View:FileDrop,Queue:FileDrop:1,Relate:KeyWords,ThisWindow)
  FDB3.Q &= Queue:FileDrop:1
  FDB3.AddSortOrder()
  FDB3.AddField(KEY:KeyWordDescription,FDB3.Q.KEY:KeyWordDescription)
  FDB3.AddField(KEY:KeyWordNumber,FDB3.Q.KEY:KeyWordNumber)
  FDB3.AddUpdateField(KEY:KeyWordDescription,LOC:Input)
  ThisWindow.AddItem(FDB3.WindowComponent)
  FDB3.DefaultFill = 0
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:KeyWords.Close
  END
  IF SELF.Opened
    INIMgr.Update('WindowSelectQuery',window)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Display
      !This code builds the filter expression for the view on the Query Result Windows
      CLEAR(GLO:FilterString)                                                  !Clear out garbage or old filter
      LOOP X# = 1 TO 4                                                         !Go through each criteria
        CASE LOC:Fields[X#]                                                    !Check what field was selected
        OF 'First Name'                                                        !First name
          GLO:FilterString = CLIP(GLO:FilterString)&' '&'PEO:FirstName ' &|    !Build expression with
          CLIP(LOC:Operator[X#])&' '''&CLIP(LOC:Value[X#])&''''                !operator and field value
        OF 'Last Name'                                                         !Last name
          GLO:FilterString = CLIP(GLO:FilterString)&' ' &'PEO:LastName ' &|
          CLIP(LOC:Operator[X#])&' '''&CLIP(LOC:Value[X#])&''''
        OF 'City'                                                              !City
          GLO:FilterString = CLIP(GLO:FilterString)&' ' &'PEO:City ' &|
          CLIP(LOC:Operator[X#])&' '''&CLIP(LOC:Value[X#])&''''
        OF 'State'                                                             !State
          GLO:FilterString = CLIP(GLO:FilterString)&' ' &'PEO:State ' &|
          CLIP(LOC:Operator[X#])&' '''&CLIP(LOC:Value[X#])&''''
        OF 'Zip Code'                                                          !Zip
          GLO:FilterString = CLIP(GLO:FilterString)&' ' &'PEO:ZipCode ' &|
          CLIP(LOC:Operator[X#])&' '''&CLIP(LOC:Value[X#])&''''
        OF 'Birthdate'                                                         !Birthday
          GLO:FilterString = CLIP(GLO:FilterString)& ' ' &'PEO:Birthdate ' &|  !Foramat the date entered
          CLIP(LOC:Operator[X#])&' '&CLIP(DEFORMAT(LOC:Value[X#],@d2))         !in the value field
        OF 'Sex'                                                               !Sex
          GLO:FilterString = ClIP(GLO:FilterString)&' ' &'PEO:Sex ' &|
          CLIP(LOC:Operator[X#])&' '''&SUB(CLIP(LOC:Value[X#]),1,1)&''''
        OF 'Keyword'                                                           !Keyword
          GLO:FilterString = CLIP(GLO:FilterString)&' ' &'PKW:KeyWordDescription ' &|
          CLIP(LOC:Operator[X#])&' '''&CLIP(LOC:Value[X#])&''''
        END
        IF X# = 4 THEN BREAK.                                                  !Check to see if the
        CASE LOC:JoinValue[X#]                                                 !criteria has been
        OF 'NONE'                                                              !filled in.  If not
           BREAK                                                               !break out because we're done
        OF 'AND'                                                               !if not add an AND
           GLO:FilterString = CLIP(GLO:FilterString)&' ' & 'AND '              !or
        OF 'OR'                                                                !an OR
            GLO:FilterString = CLIP(GLO:FilterString)&' ' & 'OR '              !to the filter and go
        END                                                                    !to the next criteria
      END
      GLO:FilterString = '('&CLIP(GLO:FilterString)&')'                        !Format the string correctly
      !Keywords are special in the filter expression.  They come from another file (child to the person
      !file).  If the filter contains a keyword criteria.  We use a view that has the keyword file
      !included, otherwise the view only has the people file.
      IF INSTRING('PKW:KeyWordDescription',CLIP(GLO:FilterString),1,1)         !Check if the filter uses Keywords
         WindowResultKeyword                                                   !View with Keyword file
      ELSE
         WindowResultNoKeyword                                                 !View w/out keyword file
      END
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?LOC:Fields_1
      !Check to make sure that the user selected something here
      IF LOC:Fields[1] = ''
        BEEP
        SELECT(?LOC:Fields_1)
      END
    OF ?LOC:Operator_1
      !Check to make sure that the user selected something here
      IF LOC:Operator[1] = ''
        BEEP
        SELECT(?LOC:Operator_1)
      END
    OF ?LOC:Fields_2
      !Check to make sure that the user selected something here
      IF LOC:Fields[2] = ''
        BEEP
        SELECT(?LOC:Fields_2)
      END
    OF ?LOC:Operator_2
      !Check to make sure that the user selected something here
      IF LOC:Operator[2] = ''
        BEEP
        SELECT(?LOC:Operator_2)
      END
    OF ?LOC:Fields_3
      !Check to make sure that the user selected something here
      IF LOC:Fields[3] = ''
        BEEP
        SELECT(?LOC:Fields_3)
      END
    OF ?LOC:Operator_3
      !Check to make sure that the user selected something here
      IF LOC:Operator[3] = ''
        BEEP
        SELECT(?LOC:Operator_3)
      END
    OF ?LOC:Fields_4
      !Check to make sure that the user selected something here
      IF LOC:Fields[4] = ''
        BEEP
        SELECT(?LOC:Fields_4)
      END
    OF ?LOC:Operator_4
      !Check to make sure that the user selected something here
      IF LOC:Operator[4] = ''
        BEEP
        SELECT(?LOC:Operator_4)
      END
    OF ?Clear
      ThisWindow.Update
      !Wipe out all criteria entered
      LOOP X# = 1 TO 4                              !Go through all four criteria and delete
        CLEAR(LOC:Fields[X#])                       !Field value
        CLEAR(LOC:Operator[X#])                     !operator
        CLEAR(LOC:Value[X#])                        !user value
        CLEAR(LOC:JoinValue[X#])                    !and join condition
      END
      UNHIDE(?LOC:Fields_1,?LOC:Value_4)             !Make sure nothing is hidden that shouldn't be
      DISPLAY
      DISABLE(?LOC:Fields_2,?LOC:Value_4)           !Disable all but first selection criteria
      
    OF ?STA:CODE
      !Put combo value into the proper criteria value
      ?STA:CODE{PROP:Hide} = TRUE
      DO List2EntryField
    OF ?LOC:Date
      !Put entry field value into the proper criteria value
      LOC:Value[LOC:Dimension] = FORMAT(LOC:Date,@d2)
      ?LOC:Date{PROP:Hide} = TRUE
      DO List2EntryField
      ALIAS
    OF ?LOC:Sex
      !Put combo value into the proper criteria value
      ?LOC:Sex{PROP:Hide} = TRUE
      DO List2EntryField
    OF ?KEY:KeyWordDescription
      !Put combo value into the proper criteria value
      ?KEY:KeyWordDescription{PROP:Hide} = TRUE
      DO List2EntryField
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeSelected PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE FIELD()
    OF ?LOC:Fields_1
      !Make sure that accept code is executed when tabbing through
      ?LOC:Fields_1{PROP:Touched} = TRUE
    OF ?LOC:Operator_1
      !Make sure accepted code is processed even when tabbing through field
      ?LOC:Operator_1{PROP:Touched} = TRUE
    OF ?LOC:Value_1
      !Set variables for showing correct combo box in value field
      LOC:Dimension = 1                             ! Criteria row
      LOC:EquateNumber = ?LOC:Value_1               ! Equate number of value field
      LOC:XPosition = ?LOC:Value_1{PROP:XPos}       ! Vertical location
      LOC:YPosition = ?LOC:Value_1{PROP:YPos}       ! Horizontal location
      DO ValueFieldLookup
      DO SelectWhat
    OF ?LOC:Fields_2
      !Make sure that accept code is executed when tabbing through
      ?LOC:Fields_2{PROP:Touched} = TRUE
    OF ?LOC:Operator_2
      !Make sure accepted code is processed even when tabbing through field
      ?LOC:Operator_2{PROP:Touched} = TRUE
    OF ?LOC:Value_2
      !Set variables for showing correct combo box in value field
      LOC:Dimension = 2                           !Criteria row
      LOC:EquateNumber = ?LOC:Value_2             !Equate for value field
      LOC:XPosition = ?LOC:Value_2{PROP:XPos}     !Horizontal position
      LOC:YPosition = ?LOC:Value_2{PROP:YPos}     !Vertical position
      DO ValueFieldLookup
      DO SelectWhat
    OF ?LOC:Fields_3
      !Make sure that accept code is executed when tabbing through
      ?LOC:Fields_3{PROP:Touched} = TRUE
    OF ?LOC:Operator_3
      !Make sure accepted code is processed even when tabbing through field
      ?LOC:Operator_3{PROP:Touched} = TRUE
    OF ?LOC:Value_3
      !Set variables for showing correct combo box in value field
      LOC:Dimension = 3                            !Criteria row
      LOC:EquateNumber = ?LOC:Value_3              !Equate of value field
      LOC:XPosition = ?LOC:Value_3{PROP:XPos}      !Horizontal position
      LOC:YPosition = ?LOC:Value_3{PROP:YPos}      !Vertical position
      DO ValueFieldLookup
      DO SelectWhat
    OF ?LOC:Fields_4
      !Make sure that accept code is executed when tabbing through
      ?LOC:Fields_4{PROP:Touched} = TRUE
    OF ?LOC:Operator_4
      !Make sure accepted code is processed even when tabbing through field
      ?LOC:Operator_4{PROP:Touched} = TRUE
    OF ?LOC:Value_4
      !Set variables for showing correct combo box in value field
      LOC:Dimension = 4                            !Criteria row
      LOC:EquateNumber = ?LOC:Value_4              !Equate for value field
      LOC:XPosition = ?LOC:Value_4{PROP:XPos}      !Horizontal position
      LOC:YPosition = ?LOC:Value_4{PROP:YPos}      !Vertical position
      DO ValueFieldLookup
      DO SelectWhat
    OF ?STA:CODE
      !Prime combo box before showing
      ?STA:Code{PROP:Use} = LOC:Value[LOC:Dimension]   !Make sure use is for current dimension
      ?STA:CODE{PROP:Touched} = TRUE                   !Make sure accept code is executed when tabbing through
    OF ?LOC:Date
      !Make sure Accepted code is executed
      ALIAS(EnterKey,TabKey)                    !Make enter key act like the tab key for this control
      ?LOC:Date{PROP:Touched} = TRUE            !Make sure accepted code is executed if tabbing through
    OF ?LOC:Sex
      !Set up combo box before showing it
      ?LOC:Sex{PROP:Use} = LOC:Value[LOC:Dimension]      !Fill the combo with correct dimension value
      ?LOC:Sex{PROP:Touched} = TRUE                      !Make sure accepted code is executed tabbing through
    OF ?KEY:KeyWordDescription
      !Set up combo box before displaying
      ?KEY:KeyWordDescription{PROP:Use} = LOC:Value[LOC:Dimension]   !Get correct dimesion value for combo display
      ?KEY:KeyWordDescription{PROP:Touched} = TRUE                   !Make sure accept code is executed when tabbing through
    END
  ReturnValue = PARENT.TakeSelected()
    CASE FIELD()
    OF ?LOC:JoinValue:Radio1
      !Code for NONE selected
      LOC:Dimension = 2                       !Set proper criteria
      DO ClearValues                          !Clear out any values in the next criteria
      ?LOC:Fields_2{PROP:DISABLE} = TRUE      !Disable the cleared fields
      ?LOC:Operator_2{PROP:DISABLE} = TRUE
      ?LOC:Value_2{PROP:DISABLE} = TRUE
      ?LOC:JoinValue_2{PROP:DISABLE} = TRUE
    OF ?LOC:JoinValue:Radio2
      !Code for AND selected
      LOC:Operator[2] = '='                            !Prime next operator with =
      DISPLAY
      ENABLE(?LOC:Fields_2,?LOC:JoinValue_2)           !Enable the next set of criteria fields
      ?LOC:JoinValue:Radio3:2{PROP:Disable} = TRUE     !Make all AND operators enabled
      ?LOC:JoinValue:Radio3:3{PROP:Disable} = TRUE
      ?LOC:JoinValue:Radio2:2{PROP:Disable} = FALSE    !Make all OR operators disabled
      ?LOC:JoinValue:Radio2:3{PROP:Disable} = FALSE
    OF ?LOC:JoinValue:Radio3
      ! Code for OR selected
      LOC:Operator[2] = '='                              !Prime next operator with =
      DISPLAY
      ENABLE(?LOC:Fields_2,?LOC:JoinValue_2)
      ?LOC:JoinValue:Radio2:2{PROP:Disable} = TRUE       !Hide AND in second row of radio buttons
      ?LOC:JoinValue:Radio2:3{PROP:Disable} = TRUE       !Hide AND in third row of radio buttons
      ?LOC:JoinValue:Radio3:2{PROP:Disable} = FALSE      !Show OR in second row of radio buttons
      ?LOC:JoinValue:Radio3:3{PROP:Disable} = FALSE      !Show OR in third row of radio buttons
    OF ?LOC:JoinValue:Radio1:2
      !Code for NONE selected
      LOC:Dimension = 3                        !Set criteria number
      DO ClearValues                           !Clear out the values for next criteria
      ?LOC:Fields_3{PROP:DISABLE} = TRUE       !Disable the entry fields for next criteria
      ?LOC:Operator_3{PROP:DISABLE} = TRUE
      ?LOC:Value_3{PROP:DISABLE} = TRUE
      ?LOC:JoinValue_3{PROP:DISABLE} = TRUE
    OF ?LOC:JoinValue:Radio2:2
      !Code for AND selected
      ENABLE(?LOC:Fields_3,?LOC:JoinValue_3)   !Enable next criteria fields
    OF ?LOC:JoinValue:Radio3:2
      !Code for OR selected
      ENABLE(?LOC:Fields_3,?LOC:JoinValue_3)      !Enable next selection criteria
    OF ?LOC:JoinValue:Radio1:3
      !Code for NONE selected
      LOC:Dimension = 4                       !Set the criteria number
      DO ClearValues                          !Clear out the fields for next criteria
      ?LOC:Fields_4{PROP:DISABLE} = TRUE      !Disable the entry fields for next criteria
      ?LOC:Operator_4{PROP:DISABLE} = TRUE
      ?LOC:Value_4{PROP:DISABLE} = TRUE
    OF ?LOC:JoinValue:Radio2:3
      !Code for AND selected
      ENABLE(?LOC:Fields_4,?LOC:Value_4)           !Enable next selection criteria fields
    OF ?LOC:JoinValue:Radio3:3
      !Code for OR selected
      ENABLE(?LOC:Fields_4,?LOC:Value_4)     !Enable next selection criteria fields
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

WindowResultKeyword PROCEDURE                         !Generated from procedure template - Window

LocalRequest         LONG
FilesOpened          BYTE
LOC:FullName         STRING(45)
LOC:StateZip         STRING(15)
LOC:FullSex          STRING(10)
BRW2::View:Browse    VIEW(People)
                       PROJECT(PEO:City)
                       PROJECT(PEO:Birthdate)
                       PROJECT(PEO:State)
                       PROJECT(PEO:ZipCode)
                       PROJECT(PEO:Sex)
                       PROJECT(PEO:IDNumber)
                       JOIN(PKW:IDNumberKey,PEO:IDNumber)
                         PROJECT(PKW:KeyWordDescription)
                       END
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
LOC:FullName           LIKE(LOC:FullName)             !List box control field - type derived from local data
GLO:FilterString       LIKE(GLO:FilterString)         !Browse hot field - type derived from global data
PKW:KeyWordDescription LIKE(PKW:KeyWordDescription)   !Browse hot field - type derived from field
LOC:StateZip           LIKE(LOC:StateZip)             !Browse hot field - type derived from local data
LOC:FullSex            LIKE(LOC:FullSex)              !Browse hot field - type derived from local data
PEO:City               LIKE(PEO:City)                 !Browse hot field - type derived from field
PEO:Birthdate          LIKE(PEO:Birthdate)            !Browse hot field - type derived from field
PEO:State              LIKE(PEO:State)                !Browse hot field - type derived from field
PEO:ZipCode            LIKE(PEO:ZipCode)              !Browse hot field - type derived from field
PEO:Sex                LIKE(PEO:Sex)                  !Browse hot field - type derived from field
PEO:IDNumber           LIKE(PEO:IDNumber)             !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BRW3::View:Browse    VIEW(PeopleKeys)
                       PROJECT(PKW:KeyWordDescription)
                       PROJECT(PKW:IDNumber)
                       PROJECT(PKW:KeyWordNumber)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?List:2
PKW:KeyWordDescription LIKE(PKW:KeyWordDescription)   !List box control field - type derived from field
PKW:IDNumber           LIKE(PKW:IDNumber)             !Primary key field - type derived from field
PKW:KeyWordNumber      LIKE(PKW:KeyWordNumber)        !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
window               WINDOW('Selection Results'),AT(,,259,148),ICON('MAIL10.ICO'),HLP('~ResultWindow'),SYSTEM,GRAY,RESIZE,MDI,IMM
                       LIST,AT(5,4,113,115),USE(?List),IMM,VSCROLL,MSG('Browsing Selected Records'),TIP('Selected People'),FORMAT('180L~  Name~@s45@'),FROM(Queue:Browse)
                       BUTTON('Add to List'),AT(8,124,71,19),USE(?Add),LEFT,FONT('Arial',12,,FONT:bold),MSG('Add people to mailing list'),TIP('Add people to mailing list'),ICON('CRDFLE12.ICO')
                       PANEL,AT(5,121,252,25),USE(?Panel3)
                       BUTTON('Return '),AT(94,124,71,19),USE(?Close),LEFT,FONT('Arial',12,COLOR:Blue,FONT:bold),MSG('Return to selection window without saving'),TIP('Return to selection window without saving'),ICON('RETURN.ICO')
                       BUTTON('Help'),AT(181,124,71,19),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                       PANEL,AT(126,6,130,114),USE(?Panel1)
                       STRING(''),AT(132,8),USE(?String5)
                       PANEL,AT(130,10,121,58),USE(?Panel2)
                       BOX,AT(132,12,117,54),USE(?Box1),COLOR(COLOR:Maroon),FILL(COLOR:Silver)
                       STRING(@s25),AT(146,18,102,10),USE(PEO:City),TRN,FONT('System',10,COLOR:Maroon,FONT:bold)
                       STRING(@s15),AT(146,29),USE(LOC:StateZip),FONT('System',10,COLOR:Maroon,FONT:bold)
                       STRING('Profile Info'),AT(131,14,21,51),USE(?String8),TRN,FONT('Arial',12,COLOR:Maroon,FONT:bold),ANGLE(2700)
                       LINE,AT(143,12,0,53),USE(?Line1),COLOR(COLOR:Maroon),LINEWIDTH(1)
                       STRING(@d2),AT(180,41),USE(PEO:Birthdate),FONT('System',10,COLOR:Maroon,FONT:bold)
                       STRING('Birthdate:'),AT(146,41),USE(?String6),FONT('System',10,COLOR:Maroon,FONT:bold)
                       STRING(@s10),AT(163,53),USE(LOC:FullSex),FONT(,,COLOR:Maroon,)
                       STRING('Sex:'),AT(146,53),USE(?String7),FONT(,,COLOR:Maroon,)
                       LIST,AT(131,73,120,42),USE(?List:2),IMM,VSCROLL,MSG('Browsing Keyword Records'),TIP('Keywords for selected person'),FORMAT('120L~ Keywords~C@s30@'),FROM(Queue:Browse:1)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW2                 CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
ResetQueue             PROCEDURE(BYTE ResetMode),DERIVED
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW2::Sort0:Locator  StepLocatorClass                 !Default Locator
BRW3                 CLASS(BrowseClass)               !Browse using ?List:2
Q                      &Queue:Browse:1                !Reference to browse queue
                     END

BRW3::Sort0:Locator  StepLocatorClass                 !Default Locator

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('WindowResultKeyword')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?List
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:MailPeople.Open
  Access:Mailers.UseFile
  SELF.FilesOpened = True
  BRW2.Init(?List,Queue:Browse.ViewPosition,BRW2::View:Browse,Queue:Browse,Relate:People,SELF)
  BRW3.Init(?List:2,Queue:Browse:1.ViewPosition,BRW3::View:Browse,Queue:Browse:1,Relate:PeopleKeys,SELF)
  OPEN(window)
  SELF.Opened=True
  BRW2.Q &= Queue:Browse
  BRW2.AddSortOrder(,PEO:CustomerNumberKey)
  BRW2.AddLocator(BRW2::Sort0:Locator)
  BRW2::Sort0:Locator.Init(,PEO:IDNumber,1,BRW2)
  BIND('LOC:FullName',LOC:FullName)
  BIND('GLO:FilterString',GLO:FilterString)
  BIND('LOC:StateZip',LOC:StateZip)
  BIND('LOC:FullSex',LOC:FullSex)
  BRW2.AddField(LOC:FullName,BRW2.Q.LOC:FullName)
  BRW2.AddField(GLO:FilterString,BRW2.Q.GLO:FilterString)
  BRW2.AddField(PKW:KeyWordDescription,BRW2.Q.PKW:KeyWordDescription)
  BRW2.AddField(LOC:StateZip,BRW2.Q.LOC:StateZip)
  BRW2.AddField(LOC:FullSex,BRW2.Q.LOC:FullSex)
  BRW2.AddField(PEO:City,BRW2.Q.PEO:City)
  BRW2.AddField(PEO:Birthdate,BRW2.Q.PEO:Birthdate)
  BRW2.AddField(PEO:State,BRW2.Q.PEO:State)
  BRW2.AddField(PEO:ZipCode,BRW2.Q.PEO:ZipCode)
  BRW2.AddField(PEO:Sex,BRW2.Q.PEO:Sex)
  BRW2.AddField(PEO:IDNumber,BRW2.Q.PEO:IDNumber)
  BRW3.Q &= Queue:Browse:1
  BRW3.AddSortOrder(,PKW:IDKeyWordKey)
  BRW3.AddRange(PKW:IDNumber,Relate:PeopleKeys,Relate:People)
  BRW3.AddLocator(BRW3::Sort0:Locator)
  BRW3::Sort0:Locator.Init(,PKW:KeyWordNumber,1,BRW3)
  BRW3.AddField(PKW:KeyWordDescription,BRW3.Q.PKW:KeyWordDescription)
  BRW3.AddField(PKW:IDNumber,BRW3.Q.PKW:IDNumber)
  BRW3.AddField(PKW:KeyWordNumber,BRW3.Q.PKW:KeyWordNumber)
  !Set variable filter for browse
  BRW2.SetFilter(GLO:FilterString)
  INIMgr.Fetch('WindowResultKeyword',window)
  BRW2.AddToolbarTarget(Toolbar)
  BRW2.ToolbarItem.HelpButton = ?Help
  BRW3.AddToolbarTarget(Toolbar)
  BRW3.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:MailPeople.Close
  END
  IF SELF.Opened
    INIMgr.Update('WindowResultKeyword',window)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Add
       POST(Event:CloseWindow)
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Add
      ThisWindow.Update
      !Add the people to the mailing list
      SET(BRW2::View:Browse)                     !Go to top of view
      LOOP UNTIL BRW2.Next()                              !Read a record
        CLEAR(MAP:Record)                       !Clear out garbage
        MAP:IDNumber = PEO:IDNumber             !Assign values in view
        MAP:MailerNumber = MAI:MailerNumber     ! to the file
        MAP:Status = 'Active'
        IF DUPLICATE(MailPeople) THEN CYCLE.    !If duplicate value, go to next record
        IF Access:MailPeople.TryInsert() THEN CYCLE.    !If a duplicate entry, go to next record
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW2.ResetQueue PROCEDURE(BYTE ResetMode)

  CODE
  PARENT.ResetQueue(ResetMode)
  !Check for records in the list
  IF RECORDS(SELF.ListQueue)
    !Alert user of possible duplicates shown on screen
    IF INSTRING('OR', GLO:FilterString,1,1)
       GLO:MessageText = 'The criteria used to select people from the |' & |
                         'profile list may cause duplicate entries to |' & |
                         'appear in the following list.  Only one copy|' & |
                         'of the personal profile will be added to the|' & |
                         'mailing list if the add option is selected. '
       MESSAGE(GLO:MessageText,'Selection Notice',ICON:Exclamation)
    END
  ELSE
    !Tell user when no record match selection criteria
    MESSAGE('NO MATCHING RECORDS FOUND','Selection Criteria',ICON:Exclamation)
    POST(Event:CloseWindow)
  END


BRW2.SetQueueRecord PROCEDURE

  CODE
  !Make the screen look better
  LOC:StateZip = CLIP(PEO:State)&' '&CLIP(PEO:ZipCode)      !Group state and zipcode
  LOC:FullSex = CHOOSE(PEO:Sex = 'M','Male','Female')
  LOC:FullName = CLIP(PEO:FirstName) & ' ' & CLIP(PEO:LastName)
  PARENT.SetQueueRecord
  SELF.Q.LOC:FullName = LOC:FullName                  !Assign formula result to display queue

UpdateMailers PROCEDURE                               !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
ActionMessage        CSTRING(40)
RecordChanged        BYTE,AUTO
LOC:LastFirst        STRING(45)
BRW2::View:Browse    VIEW(MailPeople)
                       PROJECT(MAP:Status)
                       PROJECT(MAP:IDNumber)
                       PROJECT(MAP:MailerNumber)
                       JOIN(PEO:CustomerNumberKey,MAP:IDNumber)
                         PROJECT(PEO:IDNumber)
                       END
                     END
Queue:Browse:2       QUEUE                            !Queue declaration for browse/combo box using ?Browse:2
LOC:LastFirst          LIKE(LOC:LastFirst)            !List box control field - type derived from local data
LOC:LastFirst_NormalFG LONG                           !Normal forground color
LOC:LastFirst_NormalBG LONG                           !Normal background color
LOC:LastFirst_SelectedFG LONG                         !Selected forground color
LOC:LastFirst_SelectedBG LONG                         !Selected background color
MAP:Status             LIKE(MAP:Status)               !List box control field - type derived from field
MAP:Status_NormalFG    LONG                           !Normal forground color
MAP:Status_NormalBG    LONG                           !Normal background color
MAP:Status_SelectedFG  LONG                           !Selected forground color
MAP:Status_SelectedBG  LONG                           !Selected background color
MAP:IDNumber           LIKE(MAP:IDNumber)             !Primary key field - type derived from field
MAP:MailerNumber       LIKE(MAP:MailerNumber)         !Primary key field - type derived from field
PEO:IDNumber           LIKE(PEO:IDNumber)             !Related join file key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
History::MAI:Record  LIKE(MAI:RECORD),STATIC
QuickWindow          WINDOW('Mailing List Profile'),AT(,,381,158),FONT('MS Sans Serif',8,,),IMM,ICON('MAIL10.ICO'),HLP('~MailListForm'),SYSTEM,GRAY,MDI
                       ENTRY(@s20),AT(52,13,120,12),USE(MAI:Description),MSG('Description of Maillist Group'),TIP('Mailer Description'),REQ
                       TEXT,AT(11,37,161,59),USE(MAI:MailerNotes),VSCROLL,MSG('Special Notes about the Mailing'),TIP('Mailing Notes')
                       BUTTON('     &Build Mailing List'),AT(11,101,161,22),USE(?BuildList),LEFT,FONT('Arial',12,COLOR:Maroon,FONT:bold),MSG('Build complete mailing list'),TIP('Click to build complete list'),ICON('BUILD.ICO')
                       LIST,AT(187,13,181,83),USE(?Browse:2),IMM,VSCROLL,MSG('Browsing mailing list people'),TIP('Mailing list people'),FORMAT('130L|M*~Name~@s45@36L|M*~  Status~@s8@'),FROM(Queue:Browse:2)
                       BUTTON('I'),AT(186,99,59,25),USE(?NewInsert),MSG('Add a single person to mailing list'),TIP('Add person to list'),ICON('CRDFLE12.ICO'),DEFAULT,FLAT
                       BUTTON('C'),AT(248,101,59,22),USE(?Change:3),MSG('Change status of highlighted person'),TIP('Change highlighted person'),ICON('ERASE02.ICO'),DEFAULT,FLAT
                       BUTTON('D'),AT(310,101,59,22),USE(?Delete:3),MSG('Remove a person from mailing list'),TIP('Delete selected person from list'),ICON('TRASH01.ICO'),DEFAULT,FLAT
                       BUTTON('OK'),AT(61,135,73,20),USE(?OK),LEFT,FONT('Arial',12,COLOR:Green,FONT:bold),MSG('Save and exit window'),TIP('Save & exit window'),ICON(ICON:Tick),DEFAULT
                       BUTTON('Cancel'),AT(149,135,73,20),USE(?Cancel),LEFT,FONT('Arial',12,COLOR:Red,FONT:bold),MSG('Exit window without saving'),TIP('Exit without saving'),ICON(ICON:Cross)
                       BUTTON('Help'),AT(241,135,73,20),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                       BUTTON('&OriginalInsert'),AT(326,2,51,14),USE(?Insert:3),SKIP,DISABLE,HIDE,MSG('Add a Person to Mailing List'),TIP('Press to Add a Person to List')
                       PANEL,AT(4,2,374,129),USE(?Panel3)
                       PANEL,AT(180,7,193,120),USE(?Panel1)
                       PROMPT('Description:'),AT(11,14),USE(?MAI:Description:Prompt)
                       PANEL,AT(8,7,170,120),USE(?Panel2)
                       PROMPT('Mailer Notes:'),AT(11,27),USE(?MAI:MailerNotes:Prompt),TRN
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Open                   PROCEDURE(),DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW2                 CLASS(BrowseClass)               !Browse using ?Browse:2
Q                      &Queue:Browse:2                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW2::Sort0:StepClass StepLongClass                   !Default Step Manager
BRW2::EIPManager     BrowseEIPManager                 !Browse EIP Manager for Browse using ?Browse:2
EditInPlace::MAP:Status CLASS(EditClass)              !Edit-in-place class for field MAP:Status
Init                   PROCEDURE(UNSIGNED FieldNumber,UNSIGNED ListBox,*? UseVar),DERIVED
Kill                   PROCEDURE(),DERIVED
TakeEvent              PROCEDURE(UNSIGNED Event),BYTE,DERIVED
                     END

ToolbarForm          ToolbarUpdateClass               !Form Toolbar Manager
!Define the queue for the drop list
DropEditQ    QUEUE
Status         LIKE(MAP:Status)
             END
CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a Maillist'
  OF ChangeRecord
    ActionMessage = 'Changing a Maillist'
  END
  QuickWindow{Prop:Text} = ActionMessage
  CASE SELF.Request
  OF ChangeRecord OROF DeleteRecord
    QuickWindow{Prop:Text} = QuickWindow{Prop:Text} & '  (' & MAI:Description & ')'
  OF InsertRecord
    QuickWindow{Prop:Text} = QuickWindow{Prop:Text} & '  (New)'
  END
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateMailers')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?MAI:Description
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(MAI:Record,History::MAI:Record)
  SELF.AddHistoryField(?MAI:Description,2)
  SELF.AddHistoryField(?MAI:MailerNotes,3)
  SELF.AddUpdateFile(Access:Mailers)
  SELF.AddItem(?Cancel,RequestCancelled)
  Relate:MailPeople.Open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Mailers
  IF SELF.Request = ViewRecord
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = 0
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  BRW2.Init(?Browse:2,Queue:Browse:2.ViewPosition,BRW2::View:Browse,Queue:Browse:2,Relate:MailPeople,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW2.Q &= Queue:Browse:2
  BRW2::Sort0:StepClass.Init(+ScrollSort:AllowAlpha)
  BRW2.AddSortOrder(BRW2::Sort0:StepClass,MAP:MailerNumberKey)
  BRW2.AddRange(MAP:MailerNumber,Relate:MailPeople,Relate:Mailers)
  BIND('LOC:LastFirst',LOC:LastFirst)
  BRW2.AddField(LOC:LastFirst,BRW2.Q.LOC:LastFirst)
  BRW2.AddField(MAP:Status,BRW2.Q.MAP:Status)
  BRW2.AddField(MAP:IDNumber,BRW2.Q.MAP:IDNumber)
  BRW2.AddField(MAP:MailerNumber,BRW2.Q.MAP:MailerNumber)
  BRW2.AddField(PEO:IDNumber,BRW2.Q.PEO:IDNumber)
  INIMgr.Fetch('UpdateMailers',QuickWindow)
  ToolBarForm.HelpButton=?Help
  SELF.AddItem(ToolbarForm)
  BRW2.AddToolbarTarget(Toolbar)
  BRW2.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:MailPeople.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateMailers',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Open PROCEDURE

  CODE
  PARENT.Open
  !Display the highlight bar only is list has focus
  ?Browse:2{PROP:NOBAR} = TRUE


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?BuildList
      !Prompt user for how to handle existing people in list
      IF RECORDS(Queue:Browse:2)                                   !Only display message if there are people currently in the list
        GLO:MessageText = 'DELETE the existing '&CLIP(MAI:Description)&' List?|' &|
                          'Several options exist: |' &|
                          '-DELETE all current entries, create NEW list (choose YES)|' &|
                          '-ADD to the existing list of people (choose NO)|' &|
                          '-RETURN to the Mailing Profile Screen (choose CANCEL)|'
        CASE MESSAGE(GLO:MessageText,'Select Mailing List Option',ICON:Exclamation,BUTTON:YES+BUTTON:NO+BUTTON:CANCEL,BUTTON:NO)
        OF BUTTON:YES      ! The user chooses to clear the current mailing list
          CLEAR(MAP:Record)
          MAP:MailerNumber = MAI:MailerNumber
          SET(MAP:MailerNumberKey,MAP:MailerNumberKey)          !Go to matching mailing list
          LOOP UNTIL Access:MailPeople.Next()                   !Loop through file
            IF MAP:MailerNumber <> MAI:MailerNumber THEN BREAK. !While still in current list
            Relate:MailPeople.Delete()                                  !Delete all entries
          END
        OF BUTTON:NO                                             !The user chooses to add to the current mailing list
          !No code needed, default will call Query Procedure
        OF BUTTON:CANCEL                                         !Quit from the build window
          CYCLE
        END
      END
      
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?BuildList
      ThisWindow.Update
      WindowSelectQuery
      ThisWindow.Reset
      !Update the list box to show new records in queue
      BRW2.ResetSort(1)
    OF ?NewInsert
      ThisWindow.Update
      GlobalRequest = SelectRecord
      SelectPeopleForMailer
      ThisWindow.Reset
      !Update list to show new record in the queue
      BRW2.ResetSort(1)
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord
        POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW2.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.EIP &= BRW2::EIPManager
  SELF.AddEditControl(EditInPlace::MAP:Status,2)
  SELF.AddEditControl(,1)
  SELF.ArrowAction = EIPAction:Default+EIPAction:Remain+EIPAction:RetainColumn
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert:3
    SELF.ChangeControl=?Change:3
    SELF.DeleteControl=?Delete:3
  END


BRW2.SetQueueRecord PROCEDURE

  CODE
  LOC:LastFirst = CLIP(PEO:LastName) & ', ' & CLIP(PEO:FirstName)
  PARENT.SetQueueRecord
  IF (MAP:Status = 'Active')
    SELF.Q.LOC:LastFirst_NormalFG = 32768
    SELF.Q.LOC:LastFirst_NormalBG = -1
    SELF.Q.LOC:LastFirst_SelectedFG = 65280
    SELF.Q.LOC:LastFirst_SelectedBG = 8388608
  ELSIF (MAP:Status = 'Inactive')
    SELF.Q.LOC:LastFirst_NormalFG = 128
    SELF.Q.LOC:LastFirst_NormalBG = -1
    SELF.Q.LOC:LastFirst_SelectedFG = 12632256
    SELF.Q.LOC:LastFirst_SelectedBG = 8388608
  ELSE
    SELF.Q.LOC:LastFirst_NormalFG = -1
    SELF.Q.LOC:LastFirst_NormalBG = -1
    SELF.Q.LOC:LastFirst_SelectedFG = -1
    SELF.Q.LOC:LastFirst_SelectedBG = -1
  END
  IF (MAP:Status = 'Active')
    SELF.Q.MAP:Status_NormalFG = 32768
    SELF.Q.MAP:Status_NormalBG = -1
    SELF.Q.MAP:Status_SelectedFG = 65280
    SELF.Q.MAP:Status_SelectedBG = 8388608
  ELSIF (MAP:Status = 'Inactive')
    SELF.Q.MAP:Status_NormalFG = 128
    SELF.Q.MAP:Status_NormalBG = -1
    SELF.Q.MAP:Status_SelectedFG = 12632256
    SELF.Q.MAP:Status_SelectedBG = 8388608
  ELSE
    SELF.Q.MAP:Status_NormalFG = -1
    SELF.Q.MAP:Status_NormalBG = -1
    SELF.Q.MAP:Status_SelectedFG = -1
    SELF.Q.MAP:Status_SelectedBG = -1
  END
  SELF.Q.LOC:LastFirst = LOC:LastFirst                !Assign formula result to display queue


EditInPlace::MAP:Status.Init PROCEDURE(UNSIGNED FieldNumber,UNSIGNED ListBox,*? UseVar)

  
  CODE
  ! Create the droplist, format the list, and populate the entries
  SELF.Feq = CREATE(0,CREATE:DropList)
  ASSERT(NOT ERRORCODE())
  SELF.Feq{PROP:Text} = ListBox{PROPLIST:Picture,FieldNumber}
  SELF.Feq{PROP:Use} = UseVar
  SELF.Feq{PROP:Alrt,1} = TabKey
  SELF.Feq{PROP:Alrt,2} = ShiftTab
  SELF.Feq{PROP:Alrt,3} = EnterKey
  SELF.Feq{PROP:Alrt,4} = EscKey
  SELF.Feq{PROP:Drop} = 2
  SELF.Feq{PROP:Width} = 10
  SELF.Feq{PROP:From} = DropEditQ
  SELF.Feq{PROP:Format} = '11L@s8@'
  
  DropEditQ = 'Active'
  ADD(DropEditQ)
  ASSERT(NOT ERRORCODE())
  DropEditQ = 'Inactive'
  ADD(DropEditQ)
  ASSERT(NOT ERRORCODE())
  RETURN
  PARENT.Init(FieldNumber,ListBox,UseVar)


EditInPlace::MAP:Status.Kill PROCEDURE

  CODE
  !Free the queue
  FREE(DropEditQ)
  PARENT.Kill


EditInPlace::MAP:Status.TakeEvent PROCEDURE(UNSIGNED Event)

ReturnValue          BYTE,AUTO

  CODE
  
  ReturnValue = PARENT.TakeEvent(Event)
  !Update the list with the value from the drop list
  UPDATE(SELF.Feq)
  RETURN ReturnValue

SelectPeopleForMailer PROCEDURE                       !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
LOC:FullName         STRING(40)
BRW1::View:Browse    VIEW(People)
                       PROJECT(PEO:IDNumber)
                       PROJECT(PEO:LastName)
                       PROJECT(PEO:FirstName)
                       PROJECT(PEO:MiddleInitial)
                     END
Queue:Browse:1       QUEUE                            !Queue declaration for browse/combo box using ?Browse:1
LOC:FullName           LIKE(LOC:FullName)             !List box control field - type derived from local data
PEO:IDNumber           LIKE(PEO:IDNumber)             !Primary key field - type derived from field
PEO:LastName           LIKE(PEO:LastName)             !Browse key field - type derived from field
PEO:FirstName          LIKE(PEO:FirstName)            !Browse key field - type derived from field
PEO:MiddleInitial      LIKE(PEO:MiddleInitial)        !Browse key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
QuickWindow          WINDOW('Select a Person'),AT(,,158,200),FONT('MS Sans Serif',8,,),IMM,ICON('MAIL10.ICO'),HLP('~SelectaPerson'),SYSTEM,GRAY,MDI
                       LIST,AT(10,30,137,106),USE(?Browse:1),IMM,VSCROLL,MSG('Browsing Records'),TIP('People List'),FORMAT('160L@s40@'),FROM(Queue:Browse:1)
                       BUTTON(' {17}&Select'),AT(9,139,139,22),USE(?Select:2),RIGHT,FONT('Arial',12,,FONT:bold),MSG('Choose highlighted person'),TIP('Select highlighted person'),ICON('POINT01.ICO')
                       BUTTON('Close'),AT(7,171,70,22),USE(?Close),LEFT,FONT('Arial',12,COLOR:Blue,FONT:bold),MSG('Save and exit window'),TIP('Exit window'),ICON('DOORWAY.ICO')
                       BUTTON('Help'),AT(81,171,67,22),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                       PANEL,AT(4,6,149,159),USE(?Panel1)
                       STRING('Type a letter to locate a person by last name'),AT(9,7),USE(?String1)
                       STRING(@s25),AT(8,17),USE(PEO:LastName)
                       PANEL,AT(4,167,149,31),USE(?Panel2)
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?Browse:1
Q                      &Queue:Browse:1                !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
SetQueueRecord         PROCEDURE(),DERIVED
                     END

BRW1::Sort0:Locator  IncrementalLocatorClass          !Default Locator
BRW1::Sort0:StepClass StepStringClass                 !Default Step Manager

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('SelectPeopleForMailer')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Browse:1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:MailPeople.Open
  Access:Mailers.UseFile
  SELF.FilesOpened = True
  BRW1.Init(?Browse:1,Queue:Browse:1.ViewPosition,BRW1::View:Browse,Queue:Browse:1,Relate:People,SELF)
  OPEN(QuickWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse:1
  BRW1::Sort0:StepClass.Init(+ScrollSort:AllowAlpha,ScrollBy:Runtime)
  BRW1.AddSortOrder(BRW1::Sort0:StepClass,PEO:LastNameKey)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(?PEO:LastName,PEO:LastName,1,BRW1)
  BIND('LOC:FullName',LOC:FullName)
  BRW1.AddField(LOC:FullName,BRW1.Q.LOC:FullName)
  BRW1.AddField(PEO:IDNumber,BRW1.Q.PEO:IDNumber)
  BRW1.AddField(PEO:LastName,BRW1.Q.PEO:LastName)
  BRW1.AddField(PEO:FirstName,BRW1.Q.PEO:FirstName)
  BRW1.AddField(PEO:MiddleInitial,BRW1.Q.PEO:MiddleInitial)
  INIMgr.Fetch('SelectPeopleForMailer',QuickWindow)
  BRW1.AddToolbarTarget(Toolbar)
  BRW1.ToolbarItem.HelpButton = ?Help
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:MailPeople.Close
  END
  IF SELF.Opened
    INIMgr.Update('SelectPeopleForMailer',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
    CASE ACCEPTED()
    OF ?Select:2
      !Add selected record to the file
      SELF.Update  !Make sure right record in memory
      MAP:MailerNumber = MAI:MailerNumber                   !Assign field values
      MAP:Status = 'Active'
      MAP:IDNumber = PEO:IDNumber
      IF Access:MailPeople.TryInsert() = Level:Notify       !Check for possible duplicate
        MESSAGE(CLIP(PEO:FirstName)& ' '&CLIP(PEO:LastName)&' is already a person in '&CLIP(MAI:Description)&' list.')
        SELECT(?Select:2)                                  !If dup, go back to list
        CYCLE
      END
    END
  ReturnValue = PARENT.TakeAccepted()
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.SelectControl = ?Select:2
  SELF.HideSelect = 1


BRW1.SetQueueRecord PROCEDURE

  CODE
  LOC:FullName = CLIP(PEO:FirstName) & ' ' & CLIP(PEO:LastName)
  PARENT.SetQueueRecord
  SELF.Q.LOC:FullName = LOC:FullName                  !Assign formula result to display queue

UpdateMailPeople PROCEDURE                            !Generated from procedure template - Window

CurrentTab           STRING(80)
LocalRequest         LONG
FilesOpened          BYTE
ActionMessage        CSTRING(40)
RecordChanged        BYTE,AUTO
FullPersonName       STRING(45)
QuickWindow          WINDOW('Change mailing status '),AT(150,50,247,108),FONT('MS Sans Serif',8,,),IMM,ICON('MAIL10.ICO'),HLP('~IndividualMailingStatus'),SYSTEM,GRAY,NOFRAME,MDI
                       OPTION('Status'),AT(21,40,121,22),USE(MAP:Status),BOXED,MSG('Active Status of Mailer')
                         RADIO('Active'),AT(51,48),USE(?MAP:Status:Radio1),MSG('Mailing status: Active')
                         RADIO('Inactive'),AT(91,48),USE(?MAP:Status:Radio2),MSG('Mailing status: Inactive')
                       END
                       BUTTON('OK'),AT(10,78,73,20),USE(?OK),LEFT,FONT('Arial',12,COLOR:Green,FONT:bold),MSG('Saves and Exits window'),TIP('Save & exit window'),ICON(ICON:Tick),DEFAULT
                       BUTTON('Cancel'),AT(86,78,73,20),USE(?Cancel),LEFT,FONT('Arial',12,COLOR:Red,FONT:bold),MSG('Exit window without saving'),TIP('Exit without saving'),ICON(ICON:Cross)
                       BUTTON('Help'),AT(162,78,73,20),USE(?Help),LEFT,FONT('Arial',12,COLOR:Yellow,FONT:bold),MSG('Display on-line help'),TIP('Display on-line help'),ICON(ICON:Help),STD(STD:Help)
                       PANEL,AT(7,6,231,64),USE(?Panel1)
                       STRING('Name:'),AT(27,13),USE(?String3)
                       STRING(@s45),AT(50,13,183,10),USE(FullPersonName)
                       STRING('Mailing List:'),AT(11,26),USE(?String4)
                       STRING(@s20),AT(50,26),USE(MAI:Description)
                       PANEL,AT(7,74,231,30),USE(?Panel2)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Reset                  PROCEDURE(BYTE Force=0),DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request
  OF ViewRecord
    ActionMessage = 'View Record'
  OF InsertRecord
    ActionMessage = 'Adding a MailPeople Record'
  OF ChangeRecord
    ActionMessage = 'Changing maillist status'
  END
  QuickWindow{Prop:Text} = ActionMessage
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateMailPeople')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?MAP:Status:Radio1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  FullPersonName = CLIP(PEO:FirstName) & ' ' & CLIP(PEO:LastName)
  SELF.AddUpdateFile(Access:MailPeople)
  SELF.AddItem(?Cancel,RequestCancelled)
  Relate:MailPeople.Open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:MailPeople
  IF SELF.Request = ViewRecord
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = 0
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  OPEN(QuickWindow)
  SELF.Opened=True
  INIMgr.Fetch('UpdateMailPeople',QuickWindow)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:MailPeople.Close
  END
  IF SELF.Opened
    INIMgr.Update('UpdateMailPeople',QuickWindow)
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Reset PROCEDURE(BYTE Force=0)

  CODE
  SELF.ForcedReset += Force
  IF QuickWindow{Prop:AcceptAll} THEN RETURN.
  MAI:MailerNumber = MAP:MailerNumber                 ! Assign linking field value
  Access:Mailers.Fetch(MAI:MailerNumberKey)
  PEO:IDNumber = MAP:IDNumber                         ! Assign linking field value
  Access:People.Fetch(PEO:CustomerNumberKey)
  PARENT.Reset(Force)


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord
        POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue

